!
Subroutine Normalization(max)
use Advertisement
implicit none
integer*4, intent(in) :: max
integer*4 k, j
nu(0)=dsqrt(3.d00/8.d00)
if (m.ne.0) then
  nu(0)=(2.d00*m+1.d00)/m/(m+1)/2.d00
  do k=2, 2*m, 1
    nu(0)=nu(0)/k
  end do
  nu(0)=dsqrt(nu(0)) !!!
  do k=3, 2*m-1, 2
    nu(0)=nu(0)*k
  end do
end if
if (m.eq.0) then
  do j=1, max
    nu(j)=dsqrt((2.d00*j+1.d00)/(j+1.d00)/j/4.d00) !!!
  end do
else
  do j=m, max
    nu(j)=(2.d00*j+1.d00)/(j+1.d00)/j/2.d00
    do k=1, 2*m
      nu(j)=nu(j)/(j-m+k)
    end do
    nu(j)=dsqrt(nu(j)) !!!
  end do
end if
End subroutine Normalization
!
Subroutine Normalization_
use Advertisement
implicit none
integer*4 k, j
nu(0)=dsqrt(3.d00/8.d00)
if (m.ne.0) then
  nu(0)=(2.d00*m+1.d00)/m/(m+1)/2.d00
  do k=2, 2*m, 1
    nu(0)=nu(0)/k
  end do
  nu(0)=dsqrt(nu(0)) !!!
  do k=3, 2*m-1, 2
    nu(0)=nu(0)*k
  end do
end if
if (m.eq.0) then
  do j=1, n_max
    nu(j)=dsqrt((2.d00*j+1.d00)/(j+1.d00)/j/4.d00) !!!
  end do
else
  do j=m, n_max+m-1
    nu(j-m+1)=(2.d00*j+1.d00)/(j+1.d00)/j/2.d00
    do k=1, 2*m
      nu(j-m+1)=nu(j-m+1)/(j-m+k)
    end do
    nu(j-m+1)=dsqrt(nu(j-m+1)) !!!
  end do
end if
End subroutine Normalization_
!
Subroutine Legendre(zz, p, t)
use Advertisement
implicit none
complex*16, intent(in) :: zz
complex*16, intent(out) :: p, t
if (m.eq.0) then
 p=nu(0)*zz; t=-nu(0)*cdsqrt(1.d00-zz*zz)
else
 p=nu(0)*cdsqrt(1.d00-zz*zz)**(m-1); t=m*zz*p
end if
End subroutine Legendre
!
Subroutine nLegendre(max, zz, aa, plg, tlg)
use Advertisement
implicit none
integer*4, intent(in) :: max
real*8, intent(in) :: zz, aa
real*8, intent(out) :: plg(max+1), tlg(max+1)
real*8 p, q
integer*4 nn, mm
Plg(1)=zz; Tlg(1)=-aa ! Initial values
Plg(2)=.5d00*(3*zz*zz-1); Tlg(2)=-3*zz*aa
do nn=3, max! Recursion for m=0
 Plg(nn)=((2*nn-1)*zz*Plg(nn-1)-(nn-1)*Plg(nn-2))/nn
 Tlg(nn)=zz*Tlg(nn-1)-nn*aa*Plg(nn-1)
end do
if (m.gt.0) then  ! Recursion for m=1            
  p=zz; q=1.d00
  Plg(1)=q
  do nn=1, max          
    Tlg(nn)=nn*(nn+1)*p-zz*q
    if (nn.lt.max) then 
      q=zz*q+(nn+1)*p
      p=Plg(nn+1)
      Plg(nn+1)=q
    end if
  end do                             
  do mm=2, m
    q=(2*mm-1)*aa*Plg(mm-1)
	p=Plg(mm)
	Plg(mm)=q
	do nn=mm, max
	  Tlg(nn)=(nn-mm+1)*(nn+mm)*aa*p-mm*zz*q
	  if (nn.lt.max+1) then
	    q=zz*q+(nn+mm)*aa*p
		p=Plg(nn+1)
		Plg(nn+1)=q
	  end if
	end do
  end do
end if
if (m.gt.1) then
  Plg(1:m-1)=0.d00; Tlg(1:m-1)=0.d00
end if
End subroutine nLegendre

!
Subroutine Components(er, zet, min, max, key, Pole, eM, eN)
use Advertisement
implicit none
integer*4, intent(in) :: min, max, key
complex*16, intent(in), dimension(1:*) :: Pole
complex*16, intent(out), dimension(1:3, 1:*) :: eM, eN
real*8, intent(in) :: er, zet
real*8 a
complex*16 rp, zp, ap, p, t
complex*16 f, df
integer*4 k
a=dsqrt(1.d00-zet*zet)
do k=min, max
 rp=cdsqrt(er**2+Pole(k)**2-2.d00*er*Pole(k)*zet)
 zp=(er*zet-Pole(k))/rp
 ap=cdsqrt(1.d00-zp*zp)
 if (key.eq.3) then
  rp=rp*(1.d00, 0.d00); Call Hankel(rp, f, df)
 end if
 if (key.eq.1) then
  rp=rp*r_i;  Call Bessel(rp, f, df)
 end if
 call Legendre(zp, p, t)
 if (m.eq.0) then
  eM(1, k)=(0.d00, 0.d00)
  eM(2, k)=(0.d00, 0.d00)
  eM(3, k)=-t*f/rp
  eN(1, k)=2.d00*p*f/rp/rp
  eN(2, k)=t*df/rp
  eN(3, k)=(0.d00, 0.d00)
 else
  eM(1, k)=(0.d00, 0.d00)
  eM(2, k)=m*p*f/rp
  eM(3, k)=-t*f/rp
  eN(1, k)=m*(m+1)*ap*p*f/rp/rp
  eN(2, k)=t*df/rp
  eN(3, k)=m*p*df/rp
 end if
 p=a*zp-zet*ap; t=zet*zp+a*ap 
 eM(1,k)=eM(2,k)*p; eM(2,k)=eM(2,k)*t
 f=eN(1, k)*t+eN(2, k)*p; df=-eN(1, k)*p+eN(2, k)*t
 eN(1, k)=f; eN(2, k)=df
end do
end Subroutine Components
!  
Subroutine oComponents(er, zet, min, max, key, eM, eN)
use Advertisement
implicit none
integer*4, intent(in) :: min, max, key
complex*16, intent(out), dimension(1:3, 1:*) :: eM, eN
real*8, intent(in) :: er, zet
real*8 a, p(max), t(max)
complex*16 f(max), df(max)
integer*4 k
if (key.eq.3) Call nHankel(max, er*(1.d00, 0.d00), f, df) !
if (key.eq.1) Call nBessel(max, er*(1.d00, 0.d00), f, df) !
a=dsqrt(1.d00-zet*zet)
call nLegendre(max, zet, a, p, t) !
do k=min, max
 p(k)=nu(k)*p(k)
 t(k)=nu(k)*t(k)
 if (m.eq.0) then
  eM(1, k)=(0.d00, 0.d00)
  eM(2, k)=(0.d00, 0.d00)
  eM(3, k)=-t(k)*f(k)/er
  eN(1, k)=k*(k+1)*p(k)*f(k)/er/er
  eN(2, k)=t(k)*df(k)/er
  eN(3, k)=(0.d00, 0.d00)
 else
  eM(1, k)=(0.d00, 0.d00)
  eM(2, k)=m*p(k)*f(k)/er
  eM(3, k)=-t(k)*f(k)/er
  eN(1, k)=k*(k+1)*a*p(k)*f(k)/er/er
  eN(2, k)=t(k)*df(k)/er
  eN(3, k)=m*p(k)*df(k)/er
 end if
end do
end Subroutine oComponents
!

!
Subroutine Matrix_Making(nmx ,key)
use Advertisement
implicit none
integer*4, intent(in) :: nmx, key
integer*4 i, ii, nn, ll, n_min
complex*16 mi, mj, mk, ml
real*8 rnr, rnt, r, z, w(4)
MATRIX=(0.d00,0.d00)
if (exc.lt.0.d00) then
 w(1)=-1.d00; w(2)=-width
 w(3)=width;  w(4)=1.d00
else
 w(1)=-1.d00;      w(2)=-1.d00+width
 w(3)=1.d00-width; w(4)=1.d00
end if
DO ii=1, 3 
DO i=1, node_max
 z=(w(ii+1)-w(ii))*node(i)/2.d00+(w(ii)+w(ii+1))/2.d00
 call Radius(z, r)
 call Normal(z, r, rnr, rnt)
 if (key.eq.1) Call Components(r, z, 1, nmx, 3, nPole, n_M, n_N)
 if (key.eq.2) Call oComponents(r, z, m_min, nmx, 1, n_M, n_N)
 if (key.eq.3) Call oComponents(r, z, m_min, nmx, 3, n_M, n_N)
 Call Components(r, z, 1, l_max, 1, lPole, l_M, l_N)
 n_min=m_min; if (key.eq.1) n_min=1
 Do n=n_min, nmx
  nn=n+nmx
  do l=1, l_max
   ll=l+l_max
   if (m.ne.0) then 
    Matrix(n, ll)=Matrix(n, ll)+(w(ii+1)-w(ii))/2.d00*weight(i)* &
    (rnr*(-n_M(2,n)*l_M(3,l)-n_M(3,n)*l_M(2,l))+ &
	 rnt*(n_M(1,n)*l_M(3,l)+n_M(3,n)*l_M(1,l)))
    Matrix(nn, l)=Matrix(nn, l)+(w(ii+1)-w(ii))/2.d00*weight(i)* &
    (rnr*(n_N(2,n)*l_N(3,l)+n_N(3,n)*l_N(2,l))+ &
	 rnt*(-n_N(1,n)*l_N(3,l)-n_N(3,n)*l_N(1,l)))
   end if
   Matrix(n, l)=Matrix(n, l)+(w(ii+1)-w(ii))/2.d00*weight(i)* &
    (rnr*(n_M(2,n)*l_N(3,l)-n_M(3,n)*l_N(2,l))+ &
	 rnt*(-n_M(1,n)*l_N(3,l)+n_M(3,n)*l_N(1,l)))
   Matrix(nn, ll)=Matrix(nn, ll)+(w(ii+1)-w(ii))/2.d00*weight(i)* &
    (rnr*(n_N(2,n)*l_M(3,l)-n_N(3,n)*l_M(2,l))+ &
	 rnt*(-n_N(1,n)*l_M(3,l)+n_N(3,n)*l_M(1,l)))
  end do
 End Do
END DO
END DO
rnr=pi; if (m.eq.0) rnr=2.d00*pi 
Do n=n_min, nmx
 nn=n+nmx
 do l=1, l_max
  ll=l+l_max
  if (m.ne.0) then
   mi=MATRIX(n, ll)*rnr
   ml=MATRIX(nn, l)*rnr
   MATRIX(n, ll)=(ml+r_i*mi)
   MATRIX(nn, l)=-(mi+r_i*ml)
  end if
   mj=MATRIX(n, l)*rnr
   mk=MATRIX(nn, ll)*rnr
   MATRIX(n, l)=mk+r_i*mj
   MATRIX(nn, ll)=mj+r_i*mk
 end do
End do
End Subroutine Matrix_Making
!
Subroutine oMatrix_Making(nmx ,key)
use Advertisement
implicit none
integer*4, intent(in) :: nmx, key
integer*4 i, ii, n_min
complex*16 mi, mj, mk, ml
real*8 rnr, rnt, r, z, w(4)
M11=(0.d00,0.d00); M12=(0.d00,0.d00); M21=(0.d00,0.d00); M22=(0.d00,0.d00)
if (exc.lt.0.d00) then
 w(1)=-1.d00; w(2)=-width
 w(3)=width;   w(4)=1.d00
else
 w(1)=-1.d00;         w(2)=-1.d00+width
 w(3)=1.d00-width; w(4)=1.d00
end if
DO ii=1, 3 
DO i=1, node_max
 z=(w(ii+1)-w(ii))*node(i)/2.d00+(w(ii)+w(ii+1))/2.d00
 call Radius(z, r)
 call Normal(z, r, rnr, rnt)
 if (key.eq.1) Call Components(r, z, 1, n_max, 3, nPole, n_M, n_N)
 if (key.eq.2) Call oComponents(r, z, m_min, nmx, 1, n_M, n_N)
 if (key.eq.3) Call oComponents(r, z, m_min, nmx, 3, n_M, n_N)
 Call Components(r, z, 1, l_max, 1, lPole, l_M, l_N)
 n_min=m_min; if (key.eq.1) n_min=1
 Do n=n_min, nmx
  do l=1, l_max
   if (m.ne.0) then 
    M12(n, l)=M12(n, l)+(w(ii+1)-w(ii))/2.d00*weight(i)* &
    (rnr*(-n_M(2,n)*l_M(3,l)-n_M(3,n)*l_M(2,l))+ &
	 rnt*(n_M(1,n)*l_M(3,l)+n_M(3,n)*l_M(1,l)))
    M21(n, l)=M21(n, l)+(w(ii+1)-w(ii))/2.d00*weight(i)* &
    (rnr*(n_N(2,n)*l_N(3,l)+n_N(3,n)*l_N(2,l))+ &
	 rnt*(-n_N(1,n)*l_N(3,l)-n_N(3,n)*l_N(1,l)))
   end if
   M11(n, l)=M11(n, l)+(w(ii+1)-w(ii))/2.d00*weight(i)* &
    (rnr*(n_M(2,n)*l_N(3,l)-n_M(3,n)*l_N(2,l))+ &
	 rnt*(-n_M(1,n)*l_N(3,l)+n_M(3,n)*l_N(1,l)))
   M22(n, l)=M22(n, l)+(w(ii+1)-w(ii))/2.d00*weight(i)* &
    (rnr*(n_N(2,n)*l_M(3,l)-n_N(3,n)*l_M(2,l))+ &
	 rnt*(-n_N(1,n)*l_M(3,l)+n_N(3,n)*l_M(1,l)))
  end do
 End Do
END DO
END DO
rnr=pi; if (m.eq.0) rnr=2.d00*pi 
Do n=n_min, nmx
 do l=1, l_max
  if (m.ne.0) then
   mi=M12(n, l)*rnr
   ml=M21(n, l)*rnr
   M12(n, l)=(ml+r_i*mi)
   M21(n, l)=-(mi+r_i*ml)
  end if
   mj=M11(n, l)*rnr
   mk=M22(n, l)*rnr
   M11(n, l)=mk+r_i*mj
   M22(n, l)=mj+r_i*mk
 end do
End do
End Subroutine oMatrix_Making
!
Subroutine Coefficients_Conversion_to_M_M(min, max, key)
use Advertisement
implicit none
integer*4, intent(in) :: min, max, key
complex*16 e1(max), e2(max), o1(max), o2(max), &
                    p1(max), p2(max), m1(max), m2(max)
complex*16 a1, a2, a3, a4
real*8 alpha
integer*4 i
if (key.eq.1) then
  e1=a_e1; e2=a_e2; o1=a_o1; o2=a_o2
end if
if (key.eq.2) then
  e1=b_e1; e2=b_e2; o1=b_o1; o2=b_o2
end if
if (key.eq.3) then
  e1=c_e1; e2=c_e2; o1=c_o1; o2=c_o2
end if
if (key.eq.4) then
  e1=d_e1; e2=d_e2; o1=d_o1; o2=d_o2
end if
i=(-1)**m
alpha=i*dsqrt(2.d00/pi); if (m.eq.0) alpha=dsqrt(1.d00/pi)
do n=min, max
  if (m.eq.0) then
    a1=e1(n)/alpha; a2=e2(n)/alpha
	a3=(0.d00, 0.d00); a4=(0.d00, 0.d00)
  else
    a1=(e1(n)-(0.d00,1.d00)*o1(n))/alpha
    a2=(e2(n)-(0.d00,1.d00)*o2(n))/alpha
	a3=i*(e1(n)+(0.d00,1.d00)*o1(n))/alpha
    a4=i*(e2(n)+(0.d00,1.d00)*o2(n))/alpha
  end if
  if (key.eq.1) then
      a_p1(n)=a1*i/pi; a_p2(n)=a2*i/pi; a_m1(n)=a3*i/pi; a_m2(n)=a4*i/pi
  end if
  if (key.eq.2) then
    b_p1(n)=a1; b_p2(n)=a2; b_m1(n)=a3; b_m2(n)=a4
  end if
  if (key.eq.3) then
    c_p1(n)=a1; c_p2(n)=a2; c_m1(n)=a3; c_m2(n)=a4
  end if
  if (key.eq.4) then
    d_p1(n)=a1; d_p2(n)=a2; d_m1(n)=a3; d_m2(n)=a4
  end if
end do
End Subroutine Coefficients_Conversion_to_M_M
!
Subroutine Coefficients_Conversion_to_eo(min, max, key)
use Advertisement
implicit none
integer*4, intent(in) :: min, max, key
complex*16 e1(max), e2(max), o1(max), o2(max), &
                    p1(max), p2(max), m1(max), m2(max)
complex*16 a1, a2, a3, a4
real*8 alpha
integer*4 i
i=(-1)**m
alpha=i*dsqrt(.5d00/pi); if (m.eq.0) alpha=dsqrt(1.d00/pi)
if (key.eq.1) then
  p1=a_p1; p2=a_p2; m1=a_m1; m2=a_m2
end if
if (key.eq.2) then
  p1=b_p1; p2=b_p2; m1=b_m1; m2=b_m2
end if
if (key.eq.3) then
  p1=c_p1; p2=c_p2; m1=c_m1; m2=c_m2
end if
if (key.eq.4) then
  p1=d_p1; p2=d_p2; m1=d_m1; m2=d_m2
end if
do n=min, max
  if (m.eq.0) then
    a1=p1(n)*alpha; a2=p2(n)*alpha
	a3=(0.d00, 0.d00); a4=(0.d00, 0.d00)
  else
    a1=(p1(n)+i*m1(n))*alpha
    a2=(p2(n)+i*m2(n))*alpha
	a3=(p1(n)-i*m1(n))*alpha*(0.d00,1.d00)
    a4=(p2(n)-i*m2(n))*alpha*(0.d00,1.d00)
  end if
  if (key.eq.1) then
      a_e1(n)=a1*i*pi; a_e2(n)=a2*i*pi; a_o1(n)=a3*i*pi; a_o2(n)=a4*i*pi
  end if
  if (key.eq.2) then
    b_e1(n)=a1; b_e2(n)=a2; b_o1(n)=a3; b_o2(n)=a4
  end if
  if (key.eq.3) then
    c_e1(n)=a1; c_e2(n)=a2; c_o1(n)=a3; c_o2(n)=a4
  end if
  if (key.eq.4) then
    d_e1(n)=a1; d_e2(n)=a2; d_o1(n)=a3; d_o2(n)=a4
  end if
end do
End Subroutine Coefficients_Conversion_to_eo
!
Subroutine Matrix_Conversion_to_M_M(nmin, nmax, lmin, lmax)
use Advertisement
implicit none
integer*4, intent(in) :: nmin, nmax, lmin, lmax
real*8 alpha
alpha=((-1)**m)/pi
 do n=nmin, nmax
    do l=lmin, lmax
      MATRIX(n,l)=MATRIX(n,l)*alpha
	  MATRIX(n+nmax,l+lmax)=MATRIX(n+nmax,l+lmax)*alpha
	  if (m.gt.0) then
	    MATRIX(n+nmax,l)=MATRIX(n+nmax,l)*alpha*(0.d00,1.d00)
		MATRIX(n,l+lmax)=MATRIX(n,l+lmax)*alpha*(0.d00,-1.d00)
	  end if
    end do
  end do
End Subroutine Matrix_Conversion_to_M_M
!
Subroutine oMatrix_Conversion_to_M_M(nmin, nmax, lmin, lmax)
use Advertisement
implicit none
integer*4, intent(in) :: nmin, nmax, lmin, lmax
real*8 alpha
alpha=((-1)**m)/pi
 do n=nmin, nmax
    do l=lmin, lmax
      M11(n,l)=M11(n,l)*alpha
	  M22(n,l)=M22(n,l)*alpha
	  if (m.gt.0) then
	    M21(n,l)=M21(n,l)*alpha*(0.d00,1.d00)
		M12(n,l)=M12(n,l)*alpha*(0.d00,-1.d00)
	  end if
    end do
  end do
End Subroutine oMatrix_Conversion_to_M_M
!
Subroutine Radius(zet, er)
use Advertisement
implicit none
real*8, intent(in) :: zet
real*8, intent(out) :: er
er=rad/dsqrt(1.d00-exc*zet**2)
End Subroutine Radius
!
Subroutine Normal(zet, er, nr, nt)
use Advertisement
implicit none
real*8, intent(in) :: zet, er
real*8, intent(out) :: nr, nt
nr=er*er
nt=(er**4)*zet*dsqrt(1.d00-zet*zet)*exc/(rad**2)
End Subroutine Normal
!
Subroutine IntegrationCheck(key)
use Advertisement
implicit none
integer*4, intent(in) :: key
print *, pi
call Preparations
m=m_max
m_min=m; if (m.eq.0) m_min=1
call Normalization(n_max)
lPole(1)=(0.5d00,0.d00)
lPole(2)=(0.5d00,0.d00)
nPole(1)=(0.5d00,0.d00)
nPole(2)=(0.5d00,0.d00)
call Matrix_Making(n_max, key)
call Matrix_Conversion_to_M_M(1, 2, 1, 2)
write (*,*) 'A-matrix *******************'
do n=1, n_max
 do l=1, l_max
  print *, n, l, matrix(n, l)
 end do
end do
write (*,*) 'B-matrix *******************'
do n=1, n_max
 do l=1, l_max
  print *, n, l, matrix(n, l+l_max)
 end do
end do
write (*,*) 'C-matrix *******************'
do n=1, n_max
 do l=1, l_max
  print *, n, l, matrix(n+n_max, l+l_max)
 end do
end do
write (*,*) '-D-matrix ******************'
do n=1, n_max
 do l=1, l_max
  print *, n, l, matrix(n+n_max, l)
 end do
end do
End Subroutine IntegrationCheck
!

!
subroutine bessel(rr, b, db)
use Advertisement
implicit none
complex*16, intent(in) :: rr
complex*16, intent(out) :: b, db
complex*16 al, ar, br, fr, fr_, cB(m_min)
real*8 ra, rb
integer*4 pp, mm
mm=m; if (m.eq.0) mm=1
pp=1
al=(2*mm+1)/rr; ar=al; br=(1.d00,0.d00)
fr_=al
do
 al=-al*(1.d00+1.d00/(mm+pp-.5d00))
 ar=al+1.d00/ar
 br=al+1.d00/br; if (pp.eq.1) br=al
 ra=cdabs(ar); rb=cdabs(br)
 if (ra.le.1.d-19) then
  pp=pp+1; al=-al*(1.d00+1.d00/(mm+pp-.5d00))
  br=br*(al+1.d00/br)
  fr_=fr/br
  pp=pp+1; al=-al*(1.d00+1.d00/(mm+pp-.5d00))
  br=al+1.d00/br
  fr=fr_*al/br
 end if
  if (rb.le.1.d-19) then
   pp=pp+1; al=-al*(1.d00+1.d00/(mm+pp-.5d00))
   ar=ar*(al+1.d00/ar)
   fr_=fr*ar
   pp=pp+1; al=-al*(1.d00+1.d00/(mm+pp-.5d00))
   ar=al+1.d00/ar
   fr=fr_*ar/al
 end if
 if (ra.gt.1.d-19.and.rb.gt.1.d-19) fr=fr_*ar/br
 if (cdabs(fr/fr_-1.d00).le.1.d-19) exit
 pp=pp+1; fr_=fr
end do
cB(mm)=fr
do pp=mm, 2, -1
 cB(pp-1)=(2*pp-1)/rr-1.d00/cB(pp)
end do
cB(1)=cdsin(rr)/cB(1)
do pp=2,mm
 cB(pp)=cB(pp-1)/cB(pp)
end do
b=cB(mm)
db=(fr-mm/rr)*b
end subroutine bessel
!
subroutine hankel(rr, hn, dhn)
use Advertisement
implicit none
complex*16, intent(in) :: rr
complex*16, intent(out) :: hn, dhn
complex*16 hn_1, hn_2
integer*4 pp
hn_1=cdexp((0.d00,1.d00)*rr)
hn_2=-(0.d00,1.d00)*hn_1
hn_1=-((0.d00,1.d00)/rr+1.d00)*hn_1
hn=hn_1; dhn=hn_2-hn/rr
do pp=1, m-1
 hn=(2*pp+1)*hn_1/rr-hn_2
 dhn=hn_1-(pp+1)*hn/rr
 hn_2=hn_1; hn_1=hn
end do
end subroutine hankel
!
subroutine nbessel(max, rr, B, dB)
use Advertisement
implicit none
integer*4, intent(in) :: max
complex*16, intent(in) :: rr
complex*16, intent(out) :: B(max), dB(max) !
complex*16 al, ar, br, fr, fr_
real*8 ra, rb
integer*4 pp, mm 
mm=max
pp=1
al=(2*mm+1)/rr; ar=al; br=(1.d00,0.d00)
fr_=al
do
 al=-al*(1.d00+1.d00/(mm+pp-.5d00))
 ar=al+1.d00/ar
 br=al+1.d00/br; if (pp.eq.1) br=al
 ra=cdabs(ar); rb=cdabs(br)
 if (ra.le.1.d-19) then
  pp=pp+1; al=-al*(1.d00+1.d00/(mm+pp-.5d00))
  br=br*(al+1.d00/br)
  fr_=fr/br
  pp=pp+1; al=-al*(1.d00+1.d00/(mm+pp-.5d00))
  br=al+1.d00/br
  fr=fr_*al/br
 end if
  if (rb.le.1.d-19) then
   pp=pp+1; al=-al*(1.d00+1.d00/(mm+pp-.5d00))
   ar=ar*(al+1.d00/ar)
   fr_=fr*ar
   pp=pp+1; al=-al*(1.d00+1.d00/(mm+pp-.5d00))
   ar=al+1.d00/ar
   fr=fr_*ar/al
 end if
 if (ra.gt.1.d-19.and.rb.gt.1.d-19) fr=fr_*ar/br
 if (cdabs(fr/fr_-1.d00).le.1.d-19) exit
 pp=pp+1; fr_=fr
end do
B(mm)=fr
do pp=mm, 2, -1
 B(pp-1)=(2*pp-1)/rr-1.d00/B(pp)
end do
B(1)=cdsin(rr)/B(1)
dB(1)=cdsin(rr)-B(1)/rr
do pp=2,mm
 fr=B(pp-1)/B(pp)
 dB(pp)=(B(pp)-pp/rr)*fr
 B(pp)=fr
end do
end subroutine nbessel
!
subroutine nhankel(max, rr, B, dB)
use Advertisement
implicit none
integer*4, intent(in) :: max
complex*16, intent(in) :: rr
complex*16, intent(out) :: B(max), dB(max)
integer*4 pp
B(3)=cdexp((0.d00,1.d00)*rr)
B(4)=-(0.d00,1.d00)*B(3)
B(1)=-((0.d00,1.d00)/rr+1.d00)*B(3)
B(2)=3.d00*B(1)/rr-B(4)
dB(1)=B(4)-B(1)/rr
dB(2)=B(1)-2.d00*B(2)/rr
do pp=2, max-1
 B(pp+1)=(2*pp+1)*B(pp)/rr-B(pp-1)
 dB(pp+1)=B(pp)-(pp+1)*B(pp+1)/rr
end do
end subroutine nhankel

!
Subroutine Right_Part_Making
use Advertisement
implicit none
complex*16 i, ao, ae
complex*16 p, t
i=-4.d00*(0.d00, 1.d00)*pi
do n=1, n_max
 n_M(1,n)=i*cdexp((0.d00, 1.d00)*z0*nPole(n))
end do
n=m-4*(m/4)
if (n.eq.0) i=(1.d00, 0.d00)
if (n.eq.1) i=(0.d00, 1.d00)
if (n.eq.2) i=(-1.d00, 0.d00)
if (n.eq.3) i=(0.d00, -1.d00)
ao=(1.d00, 0.d00)*z0
Call Legendre(ao, p, t)
ao=i*m*p
ae=-i*t
if (m.eq.0) ae=-(0.d00, 1.d00)*t
do n=1, n_max
 a_e1(n)=ae*n_M(1, n)*et
 a_o1(n)=ao*n_M(1, n)*ef
 a_e2( n)=(0.d00, 1.d00)*ae*n_M(1, n)*et
 a_o2(n)=-(0.d00, 1.d00)*ao*n_M(1, n)*ef
end do
End Subroutine Right_Part_Making
!
Subroutine TE_TM_Right_Part_Making
use Advertisement
implicit none
complex*16 i, ao, ae
complex*16 p, t
i=-4.d00*pi*(0.d00, 1.d00)
do n=1, n_max
 n_M(1,n)=i*cdexp((0.d00, 1.d00)*z0*nPole(n))
end do
n=m-4*(m/4)
if (n.eq.0) i=(1.d00, 0.d00)
if (n.eq.1) i=(0.d00, 1.d00)
if (n.eq.2) i=(-1.d00, 0.d00)
if (n.eq.3) i=(0.d00, -1.d00)
ao=(1.d00, 0.d00)*z0
Call Legendre(ao, p, t)
ao=i*m*p
ae=-i*t
if (m.eq.0) ae=-(0.d00, 1.d00)*t
do n=1, n_max
 a_e1(n)=ae*n_M(1, n) !ef
 a_o1(n)=ao*n_M(1, n) !et
 a_e2(n)=(0.d00, 1.d00)*ae*n_M(1, n) !et
 a_o2(n)=-(0.d00, 1.d00)*ao*n_M(1, n) !ef
end do
End Subroutine TE_TM_Right_Part_Making
!
Subroutine RightPartsCheck
use Advertisement
implicit none
real*8 est, res(2)
external Ff, Low, Up
call Preparations
m=m_max
call Normalization(1)
call Right_Part_Making
do n=1, n_max
 do l=2, 3
  l_M(l, n)=n_M(l, n); l_N(l, n)=n_N(l, n)
 end do
end do
do odd=1, 2
 do n=1, n_max
  do l=1,2
   ox=-2.d00
   call  dtwodq (Ff, -1.d00, 1.d00, Low, Up, 0.d00, 0.5d-01, 6, res(l), est)
  end do
  print *, res(1), res(2)
  print *, l_M(1+odd, n)
 end do
end do
do odd=1, 2
 do n=n_max+1, 2*n_max
  do l=1,2
   ox=-2.d00
   call  dtwodq (Ff, -1.d00, 1.d00, Low, Up, 0.d00, 0.5d-01, 6, res(l), est)
  end do
  print *, res(1), res(2)
  print *, l_N(1+odd, n-n_max)
 end do
end do
End Subroutine RightPartsCheck
!
real*8 Function Low(x)
real*8, intent(in) :: x
Low=0.d00
End Function Low
!
real*8 Function Up(x)
use Advertisement
real*8, intent(in) :: x
Up=2.d00*pi
End Function Up
!
real*8 Function Ff(x, y)
use Advertisement
implicit none
real*8, intent(in) :: x, y
integer*4 s
real*8 kr, rnr, rnt
complex*16 v1(3), v2(3), v(3)
kr=rad/dsqrt(1.d00-exc*(x**2)) !
rnr=kr*kr
rnt=(kr**4)*x*dsqrt(1.d00-x*x)*exc/(rad**2) !
s=n; if (n.gt.n_max) s=n-n_max
if (x.ne.ox) &
 Call Components(kr, x, s, s, 3, nPole, n_M, n_N) !
ox=x
Call Term(y, n, pe, pm, odd) !
Call Plain_Wave(kr, x, y, v1, v2) !
v(1)=pm(2)*v1(3)-pm(3)*v1(2)
v(2)=-pm(1)*v1(3)+pm(3)*v1(1)
v(3)=pm(1)*v1(2)-pm(2)*v1(1)
v1=v
v(1)=pe(2)*v2(3)-pe(3)*v2(2)
v(2)=-pe(1)*v2(3)+pe(3)*v2(1)
v(3)=pe(1)*v2(2)-pe(2)*v2(1)
v2=v
v1=v1+(0.d00,1.d00)*v2
if (l.eq.1) ff=dreal(rnr*v1(1)+rnt*v1(2))
if (l.eq.2) ff=dimag(rnr*v1(1)+rnt*v1(2))
end Function Ff
!
Subroutine Term(fi, num, E, H, evenness)
use Advertisement
implicit none
real*8, intent(in) :: fi
integer*4, intent(in) :: num, evenness
complex*16, intent(out), dimension(1:3) :: E, H
real*8 c, s
if (evenness.eq.1) then
 c=dcos(m*fi); s=-dsin(m*fi)
else
 s=dcos(m*fi); c=dsin(m*fi)
end if
if (num.le.n_max) then
 E(1)=n_M(1, num)*s; H(1)=n_N(1, num)*c 
 E(2)=n_M(2, num)*s; H(2)=n_N(2, num)*c
 E(3)=n_M(3, num)*c; H(3)=n_N(3, num)*s
else
 H(1)=n_M(1, num-n_max)*s; E(1)=n_N(1, num-n_max)*c 
 H(2)=n_M(2, num-n_max)*s; E(2)=n_N(2, num-n_max)*c
 H(3)=n_M(3, num-n_max)*c; E(3)=n_N(3, num-n_max)*s
end if
End Subroutine Term

!
subroutine Nodes
use Advertisement
use Numerical_libraries
implicit none
real*8, dimension(1:2) :: preset
call DGQRUL(node_max, 1, 0.d00, 0.d00, 0, preset, node, weight)
end subroutine Nodes
!
subroutine sin_lattice(factor)
use Advertisement
implicit none
real*8, intent(in) :: factor
integer*4 i
real*8 step
complex*16 length
if (exc.gt.1.d00) length=(0.d00,1.d00)*rad*dsqrt(exc-1.d00)/exc
if (exc.le.1.d00) length=rad*dsqrt(1.d00-exc*exc)/exc
if (n_max.eq.1) then
 nPole(1)=(0.d00, 0.d00); lPole(1)=(0.d00, 0.d00)
else
 step=pi/(n_max-1)
 do i=1, n_max
  nPole(i)=length*dsin(-pi/2.d00+step*(i-1))
 end do
 step=pi/(l_max-1)
 do i=1, l_max
  lPole(i)=length*dsin(-pi/2.d00+step*(i-1))
 end do
end if
End subroutine sin_lattice
!
subroutine line_lattice(factor)
use Advertisement
implicit none
real*8, intent(in) :: factor
integer*4 i, sgn
real*8 step
complex*16 length
if (exc.gt.1.d00) length=(0.d00,1.d00)*rad*dsqrt(exc*exc-1.d00)/exc
if (exc.le.1.d00) length=rad*dsqrt(1.d00-exc*exc)/exc
length=length*factor
if (n_max.eq.1) then
 nPole(1)=(0.d00, 0.d00); lPole(1)=(0.d00, 0.d00)
else
 step=2.d00/(n_max-1)
 do i=1, n_max
  nPole(i)=length*(-1.d00+step*(i-1))
 end do
 step=2.d00/(l_max-1)
 do i=1, l_max
  lPole(i)=length*(-1.d00+step*(i-1))
 end do
end if
End subroutine line_lattice
!

!
Subroutine far_Components(zet, min, max, eM, eN)
use Advertisement
implicit none
integer*4, intent(in) :: min, max
real*8, intent(in) :: zet
complex*16, intent(out) :: eM(3, *), eN(3, *)
real*8 p(n_max+terms-1), t(n_max+terms-1)
complex*16 i
call nLegendre(max, zet, dsqrt(1.d00-zet*zet), p, t)
do n=min, max
 l=n-4*(n/4)
 if(l.eq.0) i=(1.d00,0.d00)
 if(l.eq.1) i=(0.d00,-1.d00)
 if(l.eq.2) i=(-1.d00,0.d00)
 if(l.eq.3) i=(0.d00,1.d00)
 eM(2, n)=(0.d00,-1.d00)*i*m*nu(n)*p(n)
 eN(2, n)=i*nu(n)*t(n)
 eM(3, n)=(0.d00,1.d00)*eN(2, n)
 eN(3, n)=(0.d00,1.d00)*eM(2, n)
end do
End Subroutine far_Components
!
Subroutine TE_TM_Sections(nmx)
use Advertisement
implicit none
integer*4, intent(in) :: nmx
real*8 at, af, nrm, sct, scf
at=0.d00; af=0.d00; sct=0.d00; scf=0.d00
call oMatrix_Making(nmx, 2)
call oMatrix_Conversion_to_M_M(m_min, nmx, 1, l_max) !
!call Multiplication(m_min, nmx, d_e1, d_e2, d_o1, d_o2) !
call T_Matrix !
call Coefficients_Conversion_to_eo(m_min, nmx, 4) !
call far_Components(z0, m_min, nmx, n_M, n_N) 
if (m.eq.0) then
 do n=m_min, nmx
  at=at+dimag(d_e2(n)*n_N(2, n))  ! TM
  af=af+dimag(d_e1(n)*n_M(3, n))  ! TE
  sct=sct+cdabs(d_e2(n))**2  ! TM
  scf=scf+cdabs(d_e1(n))**2  ! TE
 end do
else
 do n=m_min, nmx
  at=at+dimag(d_o1(n)*n_M(2, n)+d_e2(n)*n_N(2, n)) ! TM
  af=af+dimag(d_e1(n)*n_M(3, n)+d_o2(n)*n_N(3, n)) ! TE
  sct=sct+cdabs(d_o1(n))**2+cdabs(d_e2(n))**2 ! TM
  scf=scf+cdabs(d_e1(n))**2+cdabs(d_o2(n))**2 ! TE
 end do
end if
!nrm=pi*rad*rad*dsqrt((1.d00-z0*z0)/(1.d00-exc)+z0*z0) ! shadow section
nrm=pi*rv*rv ! the shadow of equivolume sphere
teQscat=teQscat+scf/nrm*pi
tmQscat=tmQscat+sct/nrm*pi
teQexc=teQexc+4.d00*af*pi/nrm
tmQexc=tmQexc+4.d00*at*pi/nrm
End Subroutine TE_TM_Sections
!

!
subroutine random_sin_lattice(key)
use Advertisement
implicit none
integer*4, intent(in) :: key
real*4 u
integer*4 i
real*8 step
complex*16 length
if (exc.gt.1.d00) length=(0.d00,1.d00)*rad*dsqrt(exc*exc-1.d00)/exc
if (exc.le.1.d00) length=rad*dsqrt(1.d00-exc*exc)/exc
step=pi/n_max
do i=1, n_max
 call random_seed()
 call random_number(u)
 nPole(i)=length*dsin(-pi/2.d00+step*(i-1+u))
end do
step=pi/l_max
do i=1, l_max
 call random_seed()
 call random_number(u)
 lPole(i)=length*dsin(-pi/2.d00+step*(i-1+u))
end do
if (key.eq.1) then
 do i=1, n_max
  nPole(i)=nPole(i)+(0.d00,1.d00)*length/1.d02
 end do
 do i=1, l_max
  lPole(i)=nPole(i)+(0.d00,1.d00)*length/1.d02
 end do
end if
End subroutine random_sin_lattice
!
subroutine double_line_lattice(factor, shift)
use Advertisement
implicit none
real*8, intent(in) :: factor, shift
integer*4 i, sgn
real*8 step
complex*16 length
if (exc.gt.1.d00) length=(0.d00,1.d00)*rad*dsqrt(exc*exc-1.d00)/exc
if (exc.le.1.d00) length=rad*dsqrt(1.d00-exc*exc)/exc
length=length*factor
if (n_max.eq.1) then
 nPole(1)=(0.d00, 0.d00); lPole(1)=(0.d00, 0.d00)
else
 step=2.d00/(n_max-1)
 do i=1, n_max/2, 2
  nPole(i)=length*(-1.d00+step*(i-1))+(0.d00,1.d00)*length*shift
  nPole(i+1)=length*(-1.d00+step*(i-1))-(0.d00,1.d00)*length*shift
 end do
 step=2.d00/(l_max-1)
 do i=1, l_max/2, 2
  lPole(i)=length*(-1.d00+step*(i-1))+(0.d00,1.d00)*length*shift
  lPole(i+1)=length*(-1.d00+step*(i-1))-(0.d00,1.d00)*length*shift
 end do
end if
End subroutine double_line_lattice
!
Subroutine Integrals_Writing
use Advertisement
implicit none
integer*4 i
complex*16 mi, mj, mk, ml
real*8 rnr, rnt, r, z, step, mass(3, 2000)
call Preparations
nPole(1)=Et
lPole(1)=Ef
m=m_max
call Normalization
step=2.d00*0.99999/(node_max-1)
n=n_max; l=l_max
DO i=1, node_max
 z=-0.99999d00+step*(i-1)
 r=rad/dsqrt(1.d00-exc*z**2)
 rnr=-r*r
 rnt=-(r**4)*z*dsqrt(1.d00-z*z)*exc/(rad**2)
  call Components(r, z, n_max, n_max, 3, nPole, n_M, n_N)
  call Components(r, z, l_max, l_max, 1, lPole, l_M, l_N)
   if (m.ne.0) then 
    mi=(rnr*(-n_M(2,n)*l_M(3,l)-n_M(3,n)*l_M(2,l))+ &
	 rnt*(n_M(1,n)*l_M(3,l)+n_M(3,n)*l_M(1,l)))
    ml=(rnr*(n_N(2,n)*l_N(3,l)+n_N(3,n)*l_N(2,l))+ &
	 rnt*(-n_N(1,n)*l_N(3,l)-n_N(3,n)*l_N(1,l)))
   end if
   mk=(rnr*(n_M(2,n)*l_N(3,l)-n_M(3,n)*l_N(2,l))+ &
	 rnt*(-n_M(1,n)*l_N(3,l)+n_M(3,n)*l_N(1,l)))
   mj=(rnr*(n_N(2,n)*l_M(3,l)-n_N(3,n)*l_M(2,l))+ &
	 rnt*(-n_N(1,n)*l_M(3,l)+n_N(3,n)*l_M(1,l)))
!   mass(1,i)=z; mass(2,i)=dreal(ml+r_i*mi); mass(3,i)=dimag(ml+r_i*mi)!
   mass(1,i)=z; mass(2,i)=dreal(mi+r_i*ml); mass(3,i)=dimag(ml+r_i*mi)!
!   mass(1,i)=z; mass(2,i)=dreal(mj+r_i*mk); mass(3,i)=dimag(ml+r_i*mi)!
!   mass(1,i)=z; mass(2,i)=dreal(mk+r_i*mj); mass(3,i)=dimag(ml+r_i*mi)!
END DO
do i=1, node_max
 write(06, *) mass(1, i), mass(2,i), mass(3,i)
end do
End Subroutine Integrals_Writing
!
Subroutine Inc_Field_Coeff(beta, tau, mm, nn, zet)
use Advertisement
implicit none
real*8, intent(in) :: zet
integer*4 tau, mm, nn, beta
real*8 pl(n_), tl(n_), alpha
complex*16 b, bb, A(2), e(2)
m=abs(mm); n_max=nn
alpha=((-1)**m)*dsqrt(.5d00); if (m.eq.0) alpha=1.d00
call Normalization
call nLegendre(nn, zet, dsqrt(1.d00-zet*zet), pl, tl)
if (beta.eq.1) then
  e(1)=(1.d00, 0.d00); e(2)=(0.d00, 1.d00)
end if
if (beta.eq.-1) then
  e(1)=(1.d00, 0.d00); e(2)=-(0.d00, 1.d00)
end if
e=e/dsqrt(2.d00)
pl(nn)=pl(nn)*nu(nn)*alpha; tl(nn)=tl(nn)*nu(nn)*alpha
if (mm.lt.0) then
  pl(nn)=pl(nn)*((-1)**mm)
  tl(nn)=tl(nn)*((-1)**mm)
end if
if (tau.eq.1) then
  A(1)=-(0.d00, 1.d00)*mm*pl(nn); A(2)=-tl(nn)
end if
if (tau.eq.2) then
  A(2)=-(0.d00, 1.d00)*mm*pl(nn); A(1)=tl(nn)
end if
b=4.d00*pi*((0.d00, 1.d00)**(nn-tau+1))
b=b*(e(1)*A(1)+e(2)*A(2))
bb=((-1)**mm)*((0.d00, 1.d00)**(nn-1))*(beta**(tau+1))*dsqrt(2.d00*pi*(2*nn+1))
print *, b, bb
End Subroutine Inc_Field_Coeff
!
Subroutine Plus_Minus_Right_Part
use Advertisement
implicit none
complex*16 i, a1, a2
complex*16 p, t, A(2), e(2)
real*8 alpha
i=4.d00*pi*((0.d00, 1.d00)**(m_min-1))/(0.d00, 2.d00)/dsqrt(2.d00)
do n=1, n_max
 n_M(1,n)=i*cdexp((0.d00, 1.d00)*z0*nPole(n))
end do
alpha=((-1)**m)*dsqrt(.5d00); if (m.eq.0) alpha=1.d00
Call Legendre((1.d00, 0.d00)*z0, p, t)
p=p*alpha; t=t*alpha
a1=Et*(m*p+t)+Ef*(m*p-t)
a2=Et*(m*p+t)+Ef*(-m*p+t)
do n=1, n_max
 n_M(2, n)=a1*n_M(1, n)
 n_N(3, n)=a2*n_M(1, n)
end do
p=((-1)**m)*p; t=((-1)**m)*t
a1=Et*(-m*p+t)+Ef*(-m*p-t)
a2=Et*(-m*p+t)+Ef*(m*p+t)
do n=1, n_max
 n_M(3, n)=a1*n_M(1, n)
 n_N(2, n)=a2*n_M(1, n)
end do
End Subroutine Plus_Minus_Right_Part
!
Subroutine TE_TM(fi, min, max, TE, TM)
use Advertisement
implicit none
real*8, intent(in) :: fi
integer*4, intent(in) :: min, max
complex*16, intent(out) :: TE(3), TM(3)
integer*4 k
real*8 c,s
complex*16 v(3)
TE=(0.d00,0.d00); TM=(0.d00,0.d00)
c=dcos(m*fi); s=dsin(m*fi)
do k=min, max
 TE(1)=TE(1)+(n_M(1,k)*l_M(3,k)+n_N(1,k)*l_N(2,k))*c
 TE(2)=TE(2)+(n_M(2,k)*l_M(3,k)+n_N(2,k)*l_N(2,k))*c
 TE(3)=TE(3)+(n_M(3,k)*l_M(3,k)-n_N(3,k)*l_N(2,k))*s
 TM(1)=TM(1)+(-n_M(1,k)*l_M(2,k)+n_N(1,k)*l_N(3,k))*s
 TM(2)=TM(2)+(-n_M(2,k)*l_M(2,k)+n_N(2,k)*l_N(3,k))*s
 TM(3)=TM(3)+(n_M(3,k)*l_M(2,k)+n_N(3,k)*l_N(3,k))*c
end do
End Subroutine TE_TM
!
Subroutine Field_Along_Line(altitude, azimut)
use Advertisement
implicit none
real*8, intent(in) :: altitude, azimut
real*8 er, zet, fi
rs=rad/dsqrt(1.d00-exc*altitude**2)
do n=1, 100
  er=rs*(-1.d00+(n-1)*(2.d00/99.d00))
  zet=-altitude; if (er.gt.0.d00) zet=altitude
  fi=azimut+pi; if (er.gt.0.d00) fi=azimut
  call Components(dabs(er), zet, 1, l_max, 1, lPole, n_M, n_N)
  call TE_TM(fi, 1, l_max, pe, pm)
  fTE(:,n)=fTE(:,n)+pe
  fTM(:,n)=fTM(:,n)+pm
end do
End Subroutine Field_Along_Line
!
Subroutine Form_Field
use Advertisement
implicit none
real*8 d, sigma_max, sigma, tau, dsigma, dtau, dz, z, er, zet
integer*4 i, j
d=rad*dsqrt(dabs(exc/(1.d00-exc)))
sigma_max=dsqrt(1.d00/dabs(exc))
dtau=1.9998d00/99.d00
dz=2.d00*rad/dsqrt(1-exc)/99.d00
dsigma=(sigma_max-1.d00)/99.5d00
if (exc.lt.0.d00) dsigma=sigma_max/99.5d00
do i=1, 100
  z=-rad/dsqrt(1.d00-exc)+(i-1)*dz
  if (z.lt.0.d00) then
    er=-z; zet=-1.d00
  end if
  if (z.gt.0.d00) then
    er=z; zet=1.d00
  end if
  call Components(er, zet, 1, l_max, 1, lPole, n_M, n_N)
  call TE_TM(0.d00, 1, l_max, pe, pm)
  pe=et*pe+ef*pm
  amps(101,i)=dsqrt(cdabs(pe(1))**2+ cdabs(pe(2))**2+cdabs(pe(3))**2)
end do
do i=1,100
  sigma=1.d00+dsigma/2.d00+(i-1)*dsigma
  if (exc.lt.0.d00) sigma=dsigma/2.d00+(i-1)*dsigma
  do j=1,100
    tau=-0.9999d00+(j-1)*dtau
	if (exc.gt.0.d00) er=d*dsqrt(sigma**2+tau**2-1.d00)
    if (exc.lt.0.d00) er=d*dsqrt(sigma**2-tau**2+1.d00)
	zet=sigma*tau*d/er
    call Components(er, zet, 1, l_max, 1, lPole, n_M, n_N)
    call TE_TM(0.d00, 1, l_max, pe, pm)
    pe=et*pe+ef*pm
    amps(i,j)=dsqrt(cdabs(pe(1))**2+ cdabs(pe(2))**2+cdabs(pe(3))**2)
  end do
end do
End Subroutine Form_Field
!
Subroutine Form_File
use Advertisement
implicit none
real*8 d, sigma_max, sigma, tau, dsigma, dtau, dz, z, er, zet
integer*4 i, j
d=rad*dsqrt(dabs(exc/(1.d00-exc)))
sigma_max=dsqrt(1.d00/dabs(exc))
dtau=1.9998d00/99.d00
dz=rad/dsqrt(1-exc)/99.d00
dsigma=(sigma_max-1.d00)/99.5d00; if (exc.lt.0.d00) dsigma=sigma_max/99.5d00
write (06,*) '====================================================='
write (06,*) '   i  ! j !   sigma     !     tau      !  amplitude'
write (06,*) '====================================================='
do i=1,100
  sigma=1.d00+dsigma/2.d00+(i-1)*dsigma
  if (exc.lt.0.d00) sigma=dsigma/2.d00+(i-1)*dsigma
  do j=1,100
    tau=-0.9999d00+dtau/2.d00+(j-1)*dtau 
    write (06, '(2x, i3,2x, i3, 2x, d12.5, 3x, d12.5, 3x, d12.5)') , i, j, sigma, tau, amps(i, j)
  end do
end do
do i=1, 100
  z=-rad/dsqrt(1.d00-exc)+(i-1)*dz
  if (exc.gt.0.d00) then
    if (z.lt.-d) then
      tau=-1.d00; sigma=z/d
    end if
    if (z.gt.-d.and.z.lt.d) then
      sigma=1.d00; tau=z/d
    end if
	if (z.gt.d) then
	  tau=1.d00; sigma=z/d
	end if
  else
    if (z.lt.0.d00) then
      tau=-1.d00; sigma=-z/d
    end if
    if (z.gt.0.d00) then
      tau=1.d00; sigma=z/d
    end if
  end if
  j=101
  write (06, '(2x, i3,2x, i3, 2x, d12.5, 3x, d12.5, 3x, d12.5)') j, i, sigma, tau, amps(101, i)
end do
End Subroutine Form_File
!
Subroutine Term(fi, num, E, H, evenness)
use Advertisement
implicit none
real*8, intent(in) :: fi
integer*4, intent(in) :: num, evenness
complex*16, intent(out), dimension(1:3) :: E, H
real*8 c, s
if (evenness.eq.1) then
 c=dcos(m*fi); s=-dsin(m*fi)
else
 s=dcos(m*fi); c=dsin(m*fi)
end if
if (num.le.n_max) then
 E(1)=n_M(1, num)*s; H(1)=n_N(1, num)*c 
 E(2)=n_M(2, num)*s; H(2)=n_N(2, num)*c
 E(3)=n_M(3, num)*c; H(3)=n_N(3, num)*s
else
 H(1)=n_M(1, num-n_max)*s; E(1)=n_N(1, num-n_max)*c 
 H(2)=n_M(2, num-n_max)*s; E(2)=n_N(2, num-n_max)*c
 H(3)=n_M(3, num-n_max)*c; E(3)=n_N(3, num-n_max)*s
end if
End Subroutine Term
!
Subroutine Norming_Matrix(n1, n2, l1, l2)
implicit none
integer*4, intent(in) :: n1, n2, l1, l2
real*8 max, mod
do i=n1, n2
   max=-1.d00
  do j=l1, l2
     mod=cdabs(MATRIX(i,j))
     if (mod.gt.max) max=mod
  end do
  j=1; nrm(i)=1.d00
  if (max.lt.1.d00) then
    do
       max=max*2.d00   
       if (max.le.1.d00) then
	     nrm(i)=nrm(i)/2.d00
	     j=j+1
       else 
	     Exit
	   end if 
    end do
   else
    do
       max=max/2.d00
       if (max/2.d00.ge.1.d00) then
	     nrm(i)=nrm(i)*2.d00
	     j=j+1
       else 
	     Exit
	   end if 
     end do
   end if
end do
do i=n1, n2
  do j=l1, l2
       MATRIX(i,j)=MATRIX(i,j)/nrm(i)
  end do
end do
End Subroutine Norming_Matrix
!
Subroutine Norming_Right_Part(n1, n2)
implicit none
integer*4, intent(in) :: n1, n2
do i=n1, n2
  r_p(i,1)=r_p(i,1)/nrm(i)
end do
End Subroutine Norming_Right_Part
!

!
Module Advertisement
implicit none
parameter pi=3.14159265358932384626433832795d00, &
		        tolerance=1.d-08, &
				limit1=.5d-17, limit2=.5d-17
character out*11
integer*4 n, l, m, n_max, l_max, m_min, m_max, node_max, odd, switch, terms
real*8 width, exc, rv, rad, z0, rs, ox, teQexc, teQscat, tmQexc, tmQscat, pr, pz, pf !
real*8, allocatable :: node(:), weight(:), nu(:)
complex*16 r_i, Et, Ef, pe(3), pm(3)
complex*16, allocatable :: nPole(:), lPole(:)
complex*16, allocatable :: n_M(:,:), n_N(:,:), l_M(:,:), l_N(:,:)
complex*16, allocatable :: a_e1(:), a_e2(:), a_o1(:), a_o2(:)
complex*16, allocatable :: a_p1(:), a_p2(:), a_m1(:), a_m2(:)
complex*16, allocatable :: c_e1(:), c_e2(:), c_o1(:), c_o2(:)
complex*16, allocatable :: c_p1(:), c_p2(:), c_m1(:), c_m2(:)
complex*16, allocatable :: d_e1(:), d_e2(:), d_o1(:), d_o2(:)
complex*16, allocatable :: d_p1(:), d_p2(:), d_m1(:), d_m2(:)
complex*16, allocatable :: b_e1(:), b_e2(:), b_o1(:), b_o2(:)
complex*16, allocatable :: b_p1(:), b_p2(:), b_m1(:), b_m2(:)
complex*16 , allocatable :: MATRIX(:,:), M11(:,:), M12(:,:), M21(:,:), M22(:,:)
End Module Advertisement
!

!
Subroutine GEN_Solver
use Advertisement
use IMSLF90
integer*4 i, j
complex*16 sol(2*l_max,1), r_p(2*n_max, 1)
if (n_max.ne.l_max) then
  write (*,*) ' Number of equations should be equal to the number of unknowns!'
  stop
end if
c_e1=(0.d00,0.d00); c_e2=(0.d00,0.d00); c_o1=(0.d00,0.d00); c_o2=(0.d00,0.d00)
if (m.eq.0) then
  sol(1:2*l_max, 1)=(0.d00,0.d00); r_p(1:2*l_max, 1)=(0.d00,0.d00)
  do i=1, n_max
    r_p(i,1)=a_e1(i)
  end do
  call lin_sol_gen(MATRIX(1:n_max, 1:l_max), r_p, sol)
  do i=1, l_max
    c_e1(i)=sol(i,1)
  end do
  r_p(1:2*n_max, 1)=(0.d00,0.d00); sol(1:2*l_max, 1)=(0.d00,0.d00)
  do i=1, n_max
    r_p(i,1)=a_e2(i)
  end do
  call lin_sol_gen(MATRIX(n_max+1:2*n_max, l_max+1:2*l_max), r_p, sol)
  do i=1, l_max
    c_e2(i)=sol(i,1)
  end do
else
   r_p(1:2*n_max, 1)=(0.d00,0.d00); sol(1:2*l_max, 1)=(0.d00,0.d00)
  do i=1, n_max
    r_p(i,1)=a_e1(i)
    r_p(n_max+i,1)=a_o2(i)
  end do
  call lin_sol_gen(MATRIX(1:2*n_max, 1:2*l_max), r_p, sol)
  do i=1, l_max
    c_e1(i)=sol(i,1)
    c_o2(i)=sol(i+l_max,1)
  end do
  r_p(1:2*n_max, 1)=(0.d00,0.d00); sol(1:2*l_max, 1)=(0.d00,0.d00)
  do i=1, n_max
    r_p(i,1)=a_o1(i)
    r_p(n_max+i,1)=a_e2(i)
  end do
  do n=1, n_max
    do l=1, l_max
       MATRIX(n, l_max+l)=-MATRIX(n, l_max+l)
       MATRIX(n_max+n, l)=-MATRIX(n_max+n, l)
    end do
  end do
  call lin_sol_gen(MATRIX(1:2*n_max, 1:2*l_max), r_p, sol)
  do i=1, l_max
    c_o1(i)=sol(i,1)
    c_e2(i)=sol(i+l_max,1)
  end do
end if
End Subroutine GEN_Solver
!
Subroutine GEN_Solver_MM
use Advertisement
use IMSLF90
integer*4 i
complex*16 sol(2*l_max,1), r_p(2*n_max, 1)
if (n_max.ne.l_max) then
  write (*,*) ' Number of equations should be equal to the number of unknowns!'
  stop
end if
c_p1=(0.d00,0.d00); c_p2=(0.d00,0.d00); c_m1=(0.d00,0.d00); c_m2=(0.d00,0.d00)
if (m.eq.0) then
  sol=(0.d00,0.d00); r_p=(0.d00,0.d00)
  do i=1, n_max
    r_p(i,1)=a_p1(i)
  end do
  call lin_sol_gen(MATRIX(1:n_max, 1:l_max), r_p, sol)
  do i=1, l_max
    c_p1(i)=sol(i,1)
  end do
  r_p=(0.d00,0.d00); sol=(0.d00,0.d00)
  do i=1, n_max
    r_p(i,1)=a_p2(i)
  end do
  call lin_sol_gen(MATRIX(n_max+1:2*n_max, l_max+1:2*l_max), r_p, sol)
  do i=1, l_max
    c_p2(i)=sol(i,1)
  end do
else
   r_p=(0.d00,0.d00); sol=(0.d00,0.d00)
  do i=1, n_max
    r_p(i,1)=a_m1(i) !
    r_p(n_max+i,1)=a_m2(i) !
  end do
  call lin_sol_gen(MATRIX(1:2*n_max, 1:2*l_max), r_p, sol)
  do i=1, l_max
    c_m1(i)=sol(i,1) !
    c_m2(i)=sol(i+l_max,1) !
  end do
  r_p=(0.d00,0.d00); sol=(0.d00,0.d00)
  do i=1, n_max
    r_p(i,1)=a_p1(i) !
    r_p(n_max+i,1)=a_p2(i) !
  end do
  do n=1, n_max
    do l=1, l_max
       MATRIX(n, l_max+l)=-MATRIX(n, l_max+l)
       MATRIX(n_max+n, l)=-MATRIX(n_max+n, l)
    end do
  end do
  call lin_sol_gen(MATRIX(1:2*n_max, 1:2*l_max), r_p, sol)
  do i=1, l_max
    c_p1(i)=sol(i,1) !
    c_p2(i)=sol(i+l_max,1) !
  end do
end if
End Subroutine GEN_Solver_MM
!
Subroutine GEN_inversion_MM
use Advertisement
use IMSLF90
complex*16 sol(2*l_max,1), r_p(2*n_max, 1), &
                   BM0(n_max, l_max), BM(2*n_max, 2*l_max)
if (n_max.ne.l_max) then
  write (*,*) ' Number of equations should be equal to the number of unknowns!'
  stop
end if
c_p1=(0.d00,0.d00); c_p2=(0.d00,0.d00); c_m1=(0.d00,0.d00); c_m2=(0.d00,0.d00)
if (m.eq.0) then
  call lin_sol_gen(MATRIX(1:n_max, 1:l_max), r_p, sol, nrhs=0, ainv=BM0)
  MATRIX(1:n_max, 1:l_max)=BM0
  do l=1, l_max
    do n=1, n_max
	  c_p1(l)=c_p1(l)+BM0(l,n)*a_p1(n)
	end do
  end do
  call lin_sol_gen(MATRIX(n_max+1:2*n_max, l_max+1:2*l_max), r_p, sol, nrhs=0, &
                          ainv=BM0)
  MATRIX(n_max+1:2*n_max, l_max+1:2*l_max)=BM0
  do l=1, l_max
    do n=1, n_max
	  c_p2(l)=c_p2(l)+BM0(l,n)*a_p2(n)
	end do
  end do
else
  call lin_sol_gen(MATRIX, r_p, sol, nrhs=0, ainv=BM)
  do l=1, l_max
    do n=1, n_max
	  c_m1(l)=c_m1(l)+BM(l,n)*a_m1(n)+BM(l,n+n_max)*a_m2(n)
	  c_m2(l)=c_m2(l)+BM(l+l_max,n)*a_m1(n)+BM(l+l_max,n+n_max)*a_m2(n)
	end do
  end do
  MATRIX=BM
  do n=1, n_max
    do l=1, l_max
	  BM(n, l+l_max)=-BM(n, l+l_max)
	  BM(n+n_max, l)=-BM(n+n_max, l)
	end do
  end do
  do l=1, l_max
    do n=1, n_max
	  c_p1(l)=c_p1(l)+BM(l,n)*a_p1(n)+BM(l,n+n_max)*a_p2(n)
	  c_p2(l)=c_p2(l)+BM(l+l_max,n)*a_p1(n)+BM(l+l_max,n+n_max)*a_p2(n)
	end do
  end do
end if
End Subroutine GEN_inversion_MM

!
Subroutine Multiplication(nmn, nmx, e1, e2, o1, o2)
use Advertisement
implicit none
integer*4, intent(in) :: nmx, nmn
complex*16, intent(out) :: e1(n_max+terms-1), e2(n_max+terms-1), &
                                       o1(n_max+terms-1), o2(n_max+terms-1)
integer*4 nn, ll
complex*16 factor
e1=(0.d00,0.d00); e2=(0.d00,0.d00)
o1=(0.d00,0.d00); o2=(0.d00,0.d00)
if (m.ne.0) then
  do n=nmn, nmx
    do l=1, l_max
      e1(n)=e1(n)+M11(n, l)*c_e1( l)+M12(n, l)*c_o2(l)
      o2(n)=o2(n)+M21(n, l)*c_e1(l)+M22(n, l)*c_o2(l)
      o1(n)=o1(n)+M11(n, l)*c_o1(l)-M12(n, l)*c_e2(l)
      e2(n)=e2(n)-M21(n, l)*c_o1(l)+M22(n, l)*c_e2(l)
    end do
  end do 
else
  do n=nmn, nmx
    do l=1, l_max
      e1(n)=e1(n)+M11(n, l)*c_e1(l)
      e2(n)=e2(n)+M22(n, l)*c_e2(l)
    end do
  end do 
end if 
factor=-(0.d00,1.d00)/pi !!!
e1=e1*factor; e2=e2*factor
o1=o1*factor; o2=o2*factor
End Subroutine Multiplication
!
Subroutine InnerHuygens(nmx, er, zet, fi, key, huygens) 
use Advertisement
implicit none
integer*4, intent(in) :: nmx, key
real*8, intent(in) :: er, zet, fi
complex*16, intent(inout) :: huygens(3)
integer*4 i
complex*16 ev(3)
call oMatrix_Making(nmx, key) ! key=3 - inner field; key=2 - outer field  !
call Multiplication(m_min, nmx, b_e1, b_e2, b_o1, b_o2) !
if (key.eq.3) call oComponents(er, zet, m_min, nmx, 1, n_M, n_N) !
if (key.eq.2) call oComponents(er, zet, m_min, nmx, 3, n_M, n_N) !
call TE_TM(fi, m_min, nmx, b_e1, b_e2, b_o1, b_o2, pe, pm)
huygens=huygens+et*pe+ef*pm
End Subroutine InnerHuygens
!
Subroutine InnerHuygensCheck(key)
use Advertisement
implicit none
real*8 fl
integer*4, intent(in) :: key
complex*16 in_huygens(3)
call Preparations
call Nodes
pr=dreal(Et); pz=dimag(Et); pf=dreal(Ef)
m=m_max 
m_min=m; if (m.eq.0) m_min=1
b_e1(1:l_max)=(1.d00,0.d00); b_e2(1:l_max)=(1.d00,0.d00)
b_o1(1:l_max)=(1.d00,0.d00); b_o2(1:l_max)=(1.d00,0.d00)
call Normalization(terms)
call Components(pr, pz, 1, l_max, key, lPole, n_M, n_N)
call TE_TM(pf, 1, l_max, b_e1, b_e2, b_o1, b_o2, pe, pm)
pm=pe+pm
fl=cdabs(pm(1)**2)+cdabs(pm(2)**2)+cdabs(pm(3)**2)
print *, pm(1)
print *, pm(2)
print *, pm(3)
print *, fl
write(*,*) '**************************'
in_huygens=(0.d00, 0.d00)
call InnerHuygens(n_max, pr, pz, pf, 3, in_huygens)
rs=cdabs(in_huygens(1)**2)+cdabs(in_huygens(2)**2)+cdabs(in_huygens(3)**2)
print *, in_huygens(1)
print *, in_huygens(2)
print *, in_huygens(3)
print *, dabs(rs-fl)
End Subroutine InnerHuygensCheck

Subroutine T_Matrix
use Advertisement
implicit none
complex*16 T_M11, T_M12, T_M21, T_M22, factor
integer*4 i, ii, ll
factor=(0.d00,-1.d00)*((-1)**m)
d_p1=(0.d00,0.d00); d_p2=(0.d00,0.d00); d_m1=(0.d00,0.d00); d_m2=(0.d00,0.d00)
if (m.eq.0) then
  do n=m_min, m_min+terms-1
    do l=1, n_max
	  T_M11=(0.d00,0.d00); T_M12=(0.d00,0.d00)
	  T_M21=(0.d00,0.d00); T_M22=(0.d00,0.d00)
      do i=1, l_max
	    T_M11=T_M11+M11(n,i)*MATRIX(i,l)
		T_M22=T_M22+M22(n,i)*MATRIX(i+n_max,l+l_max)
	  end do
      T_M11=T_M11*factor; T_M22=T_M22*factor
	  d_p1(n)=d_p1(n)+T_M11*a_p1(l)
	  d_p2(n)=d_p2(n)+T_M22*a_p2(l)
	  write(07,*) dreal(T_M11)
	  write(07,*) dimag(T_M11)
	  write(07,*) dreal(T_M22)
	  write(07,*) dimag(T_M22)
    end do
  end do
else
  do n=m_min, m_min+terms-1
    do l=1, n_max
	  ll=l+l_max
	  T_M11=(0.d00,0.d00); T_M12=(0.d00,0.d00)
      T_M21=(0.d00,0.d00); T_M22=(0.d00,0.d00)
      do i=1, l_max
	    ii=i+n_max
	    T_M11=T_M11+M11(n,i)*MATRIX(i,l)+M12(n,i)*MATRIX(ii,l)
		T_M12=T_M12+M11(n,i)*MATRIX(i,ll)+M12(n,i)*MATRIX(ii,ll)
		T_M21=T_M21+M21(n,i)*MATRIX(i,l)+M22(n,i)*MATRIX(ii,l)
		T_M22=T_M22+M21(n,i)*MATRIX(i,ll)+M22(n,i)*MATRIX(ii,ll)
	  end do
	  T_M11=T_M11*factor; T_M22=T_M22*factor
	  T_M12=T_M12*factor; T_M21=T_M21*factor
	  d_m1(n)=d_m1(n)+T_M11*a_m1(l)+T_M12*a_m2(l) 
	  d_m2(n)=d_m2(n)+T_M21*a_m1(l)+T_M22*a_m2(l) 
	  d_p1(n)=d_p1(n)+T_M11*a_p1(l)-T_M12*a_p2(l) 
	  d_p2(n)=d_p2(n)-T_M21*a_p1(l)+T_M22*a_p2(l) 
	  write(07,*) dreal(T_M11)
	  write(07,*) dimag(T_M11)
	  write(07,*) dreal(T_M12)
	  write(07,*) dimag(T_M12)
	  write(07,*) dreal(T_M21)
	  write(07,*) dimag(T_M21)
	  write(07,*) dreal(T_M22)
	  write(07,*) dimag(T_M22)
    end do
  end do
end if
End Subroutine T_Matrix
!
Subroutine T_Matrix_DownLoad
use Advertisement
implicit none
real*8 re, im
integer*4 nn
rewind(7)
do n=1, terms
  do l=1, n_max
    read(07,*) re
	read(07,*) im; M11(n,l)=dcmplx(re,im)
	read(07,*) re
	read(07,*) im; M22(n,l)=dcmplx(re,im)
  end do
end do
do m=1, m_max
  do n=1, terms
    nn=n+m*terms
    do l=1, n_max
	  read(07,*) re
	  read(07,*) im; M11(nn,l)=dcmplx(re,im)
	  read(07,*) re
	  read(07,*) im; M12(nn,l)=dcmplx(re,im)
	  read(07,*) re
	  read(07,*) im; M21(nn,l)=dcmplx(re,im)
	  read(07,*) re
	  read(07,*) im; M22(nn,l)=dcmplx(re,im)
	end do
  end do
end do
End Subroutine T_Matrix_DownLoad
!
Subroutine W_Matrix(nn, ll, kk, ww)
use Advertisement
implicit none
integer*4, intent(in) :: nn, ll, kk
complex*16, intent(out) :: ww
complex*16 W11, W12, W21, W22
integer*4 i, ii
W11=(0.d00,0.d00); W12=(0.d00,0.d00); W21=(0.d00,0.d00); W22=(0.d00,0.d00)
if (m.eq.0) then
  ww=(0.d00,0.d00) 
  if (kk-2*(kk/2).eq.0) then
    do i=1, terms
      W11=W11+DCONJG(M11(i,nn))*M11(i,ll)+DCONJG(M21(i,nn))*M21(i,ll)
	  W22=W22+DCONJG(M12(i,nn))*M12(i,ll)+DCONJG(M22(i,nn))*M22(i,ll)
    end do
    ww=W11+W22
  end if
else
  if (kk-2*(kk/2).eq.0) then
	do i=1,terms
	  ii=i+m*terms
      W11=W11+DCONJG(M11(ii,nn))*M11(ii,ll)+DCONJG(M21(ii,nn))*M21(ii,ll)
	  W22=W22+DCONJG(M12(ii,nn))*M12(ii,ll)+DCONJG(M22(ii,nn))*M22(ii,ll)
	end do
	ww=2.d00*(W11+W22)
  else
    do i=1,terms
	  ii=i+m*terms
      W12=W12+DCONJG(M11(ii,nn))*M12(ii,ll)+DCONJG(M21(ii,nn))*M22(ii,ll)
	  W21=W21+DCONJG(M12(ii,nn))*M11(ii,ll)+DCONJG(M22(ii,nn))*M21(ii,ll)
	end do
    ww=2.d00*(W12+W21)
  end if
end if
End Subroutine W_Matrix
!
Subroutine T_Matrix_12(nn,ll, nn1, tt, tm, key)
use Advertisement
implicit none
integer*4, intent(in) :: nn, ll, nn1, tt, key
complex*16, intent(out) :: tm
integer*4 st, nnn
real*8 sw1, sw2
st=tt; if (tt.eq.0) st=1
sw1=2.d00; if (tt.eq.0) sw1=1.d00
sw2=2.d00; if (tt.eq.0) sw2=0.d00
nnn=nn+m*terms
if ((nn+nn1+st)-2*((nn+nn1+st)/2).eq.0) then
  if (key.eq.1) tm=sw1*(M11(nnn,ll)+M22(nnn,ll))
  if (key.eq.2) tm=sw1*(M11(nnn,ll)-M22(nnn,ll))
else
  if (key.eq.1) tm=sw2*(M12(nnn,ll)+M21(nnn,ll))
  if (key.eq.2) tm=sw2*(M12(nnn,ll)-M21(nnn,ll))
end if
End Subroutine T_Matrix_12
!

!
Subroutine Route_with_Field_at_a_Reference_Point
use Advertisement
implicit none
real*8 fl, fl_, add
complex*16 field(3), in_huygens(3), ad(3)
call Preparations
allocate(node(1:node_max), weight(1:node_max))
allocate(nPole(1:n_max), lPole(1:l_max))
allocate(a_e1(1:n_max), a_e2(1:n_max), a_o1(1:n_max), a_o2(1:n_max))
allocate(a_p1(1:n_max), a_p2(1:n_max), a_m1(1:n_max), a_m2(1:n_max))
allocate(c_e1(1:l_max), c_e2(1:l_max), c_o1(1:l_max), c_o2(1:l_max))
allocate(c_p1(1:l_max), c_p2(1:l_max), c_m1(1:l_max), c_m2(1:l_max))
n=n_max+terms-1
allocate(b_e1(1:n), b_e2(1:n), b_o1(1:n), b_o2(1:n))
allocate(d_e1(1:n), d_e2(1:n), d_o1(1:n), d_o2(1:n)) 
allocate(b_p1(1:n), b_p2(1:n), b_m1(1:n), b_m2(1:n))
allocate(d_p1(1:n), d_p2(1:n), d_m1(1:n), d_m2(1:n))
allocate(n_M(1:3,1:n), n_N(1:3,1:n), l_M(1:3,1:l_max), l_N(1:3,1:l_max))
call Line_Lattice(1.0d00)
call Nodes
exc=1.d00-exc*exc
fl_=-1.d00
in_huygens=(0.d00, 0.d00)
field=(0.d00, 0.d00)
teQexc=0.d00; teQscat=0.d00; tmQexc=0.d00; tmQscat=0.d00;
m=0 !
do
  m_min=m; if (m.eq.0) m_min=1
  allocate(MATRIX(1:2*n_max, 1:2*l_max))
  allocate(nu(0:m_min+terms-1))
  call Normalization(m_min+terms-1)
  call Matrix_Making(n_max, 1)
  call TE_TM_Right_Part_Making
  call Coefficients_Conversion_to_M_M(1, n_max, 1)
  call Matrix_Conversion_to_M_M(1, n_max, 1, l_max)
!  call GEN_Solver_MM
  call GEN_Inversion_MM !
  call Coefficients_Conversion_to_eo(1, l_max, 3)
  call Components(pr, pz, 1, l_max, 1, lPole, n_M, n_N)
  call TE_TM(pf, 1, l_max, c_e1, c_e2, c_o1, c_o2, pe, pm)
  ad=et*pe+ef*pm
  field=ad+field
  fl=(cdabs(field(1))**2+cdabs(field(2))**2+cdabs(field(3))**2)
  add=(cdabs(ad(1))**2+cdabs(ad(2))**2+cdabs(ad(3))**2)
  write(*,*) 'm=', m,  fl, add
  l=m_min+terms-1 !
  allocate(M11(m_min:l,1:l_max), M12(m_min:l,1:l_max), &
               M21(m_min:l,1:l_max), M22(m_min:l,1:l_max))
  call InnerHuygens(m_min+terms-1, pr, pz, pf, 3, in_huygens)
  call TE_TM_Sections(m_min+terms-1)
  deallocate(MATRIX, M11, M12, M21, M22, nu)
  if (m.eq.n_max) write (*,*) 'm=n_max restriction achieved'
  if (dabs(fl-fl_)/fl.lt.tolerance.or.m.eq.n_max) Exit 
  fl_=fl
  m=m+1
end do
deallocate( n_M, n_N, l_M, l_N)
deallocate(node, weight, nPole, lPole)
deallocate(a_e1, a_e2, a_o1, a_o2, a_p1, a_p2, a_m1, a_m2)
deallocate(c_e1, c_e2, c_o1, c_o2, c_p1, c_p2, c_m1, c_m2)
deallocate(b_e1, b_e2, b_o1, b_o2, d_e1, d_e2, d_o1, d_o2)
deallocate(b_p1, b_p2, b_m1, b_m2, d_p1, d_p2, d_m1, d_m2)
call Plain_Wave(pr, pz, pf, pe, pm)
pm=in_huygens+pe
write(*,*) '************************'
print *, 'reslength=', &
          dsqrt((cdabs(pm(1))**2+ cdabs(pm(2))**2+cdabs(pm(3))**2)/&
          (cdabs(pe(1))**2+ cdabs(pe(2))**2+cdabs(pe(3))**2))
print *, 'teQexc=', teQexc
print *, 'tmQexc=', tmQexc
print *, 'teQscat=', teQscat
print *, 'tmQscat=', tmQscat
m_max=m
l=(m_max+1)*terms
allocate(M11(1:l,1:n_max), M12(1:l,1:n_max), M21(1:l,1:n_max), M22(1:l,1:n_max))
call T_Matrix_DownLoad
deallocate(M11, M12, M21, M22)
End Subroutine Route_with_Field_at_a_Reference_Point
!

!
subroutine Preparations
use Advertisement
implicit none
open (unit=07,file='t_m.dat', status='unknown', access='sequential')
open (unit=05,file='Input.dat',status='old', access='sequential')
read (5, '(a11)') out
open (unit=06,file=out, status='unknown', access='sequential')
read (5, '(i4)') n_max
read (5, '(i4)') l_max
read (5, '(i4)') m_max
read (5, '(i4)') terms
read (5, '(i6)') node_max
read (5, '(f8.5)') width
read (5, '(f8.5)') exc
read (5, '(f8.5)') rad
r_i=dcmplx(exc, rad)
read (5, '(f8.5)') z0
write (*,*) 'inc. angle=', z0
z0=dcos(pi*z0/180.d00)
read (5, '(f8.5)') rad
read (5, '(f8.5)') exc
et=dcmplx(rad, exc)
read (5, '(f8.5)') rad
read (5, '(f8.5)') exc
ef=dcmplx(rad, exc)
rad=dsqrt(cdabs(et)**2+cdabs(ef)**2)
et=et/rad; ef=ef/rad
read (5, '(f8.5)') rv
read (5, '(f8.5)') exc
rad=rv*(exc**(1.d00/3.d00))
write (*,*) 'rad=', rad
read (5, '(f8.5)') pr
write (*,*) ' pr=', pr
read (5, '(f8.5)') pz
write (*,*) ' pz=', pz
pz=dcos(pi*pz/180.d00)
read (5, '(f8.5)') pf
write (*,*) ' pf=', pf
pf=2.d00*pi*pf/360.d00
write (*,*) 'exc=', exc
write (*,*) 'n_max=', n_max, '  l_max=', l_max, '  terms=', terms
write (*,*) 'node_max=', node_max, '  width=', width 
write (*,*) 'r_i=', r_i
end subroutine Preparations
!

!
Subroutine Field(fi, min, max, e1, e2, o1, o2, E)
use Advertisement
implicit none
real*8, intent(in) :: fi
integer*4, intent(in) :: min, max
complex*16, intent(in) :: e1(n_max+terms-1), e2(n_max+terms-1), &
                                     o1(n_max+terms-1), o2(n_max+terms-1)
complex*16, intent(out), dimension(1:3) :: E
real*8 c,s
integer*4 k
E=(0.d00,0.d00)
c=dcos(m*fi); s=dsin(m*fi)
do k=min, max
 E(1)=E(1)+n_M(1,k)*(-e1(k)*s+o1(k)*c)+&
                  n_N(1,k)*(e2(k)*c+o2(k)*s)
 E(2)=E(2)+n_M(2,k)*(-e1(k)*s+o1(k)*c)+&
                  n_N(2,k)*(e2(k)*c+o2(k)*s)
 E(3)=E(3)+n_M(3,k)*(e1(k)*c+o1(k)*s)+&
                  n_N(3,k)*(-e2(k)*s+o2(k)*c)
end do
End Subroutine Field
!
Subroutine TE_TM(fi, min, max, e1, e2, o1, o2, TE, TM)
use Advertisement
implicit none
real*8, intent(in) :: fi
complex*16, intent(in) :: e1(n_max+terms-1), e2(n_max+terms-1), &
                                     o1(n_max+terms-1), o2(n_max+terms-1)
integer*4, intent(in) :: min, max
complex*16, intent(out) :: TE(3), TM(3)
integer*4 k
real*8 c,s
complex*16 v(3)
TE=(0.d00,0.d00); TM=(0.d00,0.d00)
c=dcos(m*fi); s=dsin(m*fi)
do k=min, max
 TE(1)=TE(1)+(n_M(1,k)*o1(k)+n_N(1,k)*e2(k))*c
 TE(2)=TE(2)+(n_M(2,k)*o1(k)+n_N(2,k)*e2(k))*c
 TE(3)=TE(3)+(n_M(3,k)*o1(k)-n_N(3,k)*e2(k))*s
 TM(1)=TM(1)+(-n_M(1,k)*e1(k)+n_N(1,k)*o2(k))*s
 TM(2)=TM(2)+(-n_M(2,k)*e1(k)+n_N(2,k)*o2(k))*s
 TM(3)=TM(3)+(n_M(3,k)*e1(k)+n_N(3,k)*o2(k))*c
end do
End Subroutine TE_TM
!
Subroutine Plain_Wave(er, zet, fi, el, mag)
use Advertisement
implicit none
real*8, intent(in) :: er, zet, fi
complex*16, intent(out) :: el(3), mag(3)
real*8 c_s(3,3), sz, sf, cf, sz0
complex*16 v(3)
sz0=dsqrt(1.d00-z0*z0)
el(1)=et*z0;    mag(1)=-ef*z0
el(2)=ef;         mag(2)=et
el(3)=-et*sz0; mag(3)=ef*sz0
sf=dsin(fi); cf=dcos(fi); sz=dsqrt(1.d00-zet*zet)
c_s(1,1)=sz*cf;  c_s(1,2)=sz*sf;  c_s(1,3)=zet
c_s(2,1)=zet*cf; c_s(2,2)=zet*sf; c_s(2,3)=-sz
c_s(3,1)=-sf;      c_s(3,2)=cf;       c_s(3,3)=0.d00
v=matmul(c_s, el); el=v
v=matmul(c_s, mag); mag=v
v(1)=cdexp((0.d00,1.d00)*(er*sz*cf*sz0+er*zet*z0))
el=el*v(1); mag=mag*v(1)
End Subroutine Plain_Wave

!
Subroutine Reg_SVD_Solver(key)
! key=1 -- regularization; key=2 -- too small singular values are cut away (preferred);
! key=any_other_number -- standard singular value decomposition
use Advertisement
use IMSLF90
implicit none
integer*4, intent(in) :: key
real*8 ro(1:2*l_max)
complex*16 f(1:2*n_max), r_p(2*n_max,1), sol(2*l_max,1), &
                   U(2*n_max,2*n_max), V(2*l_max,2*l_max)
real*8 lambda, nrm(2*n_max)
integer*4 s_max, number, i, j
lambda=0.d00
if (m.eq.0) then
 s_max=l_max; number=s_max
 r_p=(1.d00,0.d00); sol=(0.d00,0.d00); ro=0.d00
! call Norming_Matrix(1, n_max, 1, l_max) !!!
 call lin_sol_svd(MATRIX(1:n_max, 1:l_max), r_p, sol, s=ro, u=U, v=V)
! call Norming_Right_Part(1, n_max) !!!
 call Projection(n_M(2,:), n_N(2,:))
 if (key.eq.2) call Number_Search
 if (key.eq.1) call Lambda_Search
 print *, ro(number)/ro(1), lambda, number
 call Solution_Assembling(l_M(2,:), l_N(2,:))
 number=s_max
 r_p=(1.d00,0.d00); sol=(0.d00,0.d00); ro=0.d00
! call Norming_Matrix(n_max+1, 2*n_max, l_max+1, 2*l_max)
 call lin_sol_svd(MATRIX(n_max+1:2*n_max, l_max+1:2*l_max), r_p, sol, &
                         s=ro, u=U, v=V)
! call Norming_Right_Part(1, n_max)
 call Projection(n_N(2,:), n_M(2,:))
 if (key.eq.2) call Number_Search
 if (key.eq.1) call Lambda_Search
 print *, ro(number)/ro(1), lambda, number
 call Solution_Assembling(l_N(2,:), l_M(2,:))
else
 s_max=2*l_max; number=s_max
 r_p=(1.d00,0.d00); sol=(0.d00,0.d00); ro=0.d00
! call Norming_Matrix(1, 2*n_max, 1, 2*l_max)
 call lin_sol_svd(MATRIX(1:2*n_max, 1:2*l_max), r_p, sol, s=ro, u=U, v=V)
! call Norming_Right_Part(1, 2*n_max)
 call Projection(n_M(2,:), n_N(3,:))
 if (key.eq.2) call Number_Search
 if (key.eq.1) call Lambda_Search
 print *, ro(number)/ro(1), lambda, number
 call Solution_Assembling(l_M(2,:), l_N(3,:))
 do i=n_max+1, 2*n_max !*****Sign Change to Obtain theSecond System************
 do j=1, 2*n_max
  U(i, j)=-U(i, j)
 end do
end do
do i=l_max+1, 2*l_max
 do j=1, 2*l_max
  V(i, j)=-V(i, j)
 end do
end do !***************************************************************
! call Norming_Right_Part(1, 2*n_max)
 call Projection(n_M(3,:), n_N(2,:))
 if (key.eq.1) call Lambda_Search
 print *, ro(number)/ro(1), lambda, number
 call Solution_Assembling(l_M(3,:), l_N(2,:))
end if
Contains
!
!*********The Evaluation of Right Part Projections on Left Singular Vectors**********
Subroutine Projection(ff1, ff2)
implicit none
complex*16, intent(in) :: ff1(n_max), ff2(n_max)
complex*16 ff(2*n_max)
f=(0.d00, 0.d00)
if (m.eq.0) then
 do i=1, n_max
  do j=1, n_max
   f(i)=f(i)+ff1(j)*DCONJG(U(j, i))
  end do
 end do
else
 do i=1, n_max
  ff(i)=ff1(i); ff(i+n_max)=ff2(i)
 end do
 do i=1, 2*n_max
  do j=1, 2*n_max
   f(i)=f(i)+ff(j)*DCONJG(U(j, i))
  end do
 end do
end if
End Subroutine Projection
!
!*******Solution Expression via Singular Decomposotion*************************
Subroutine Solution_Assembling(ff1, ff2)
implicit none
complex*16, intent(out) :: ff1(l_max), ff2(l_max)
if (m.eq.0) then
 ff1=(0.d00, 0.d00)
 do i=1, number !
  ff1(1:l_max)=ff1(1:l_max)+f(i)*ro(i)/(ro(i)**2+lambda)*V(1:l_max, i)
 end do
else
 ff1=(0.d00, 0.d00); ff2=(0.d00, 0.d00)
 do i=1, number !
  ff1(1:l_max)=ff1(1:l_max)+f(i)*ro(i)/(ro(i)**2+lambda)*V(1:l_max, i)
  ff2(1:l_max)=ff2(1:l_max)+f(i)*ro(i)/(ro(i)**2+lambda)*V(1+l_max:2*l_max, i)
 end do
end if
End Subroutine Solution_Assembling
!
!*******************Optimal Number of Terms Search***********************
Subroutine Number_Search
implicit none
real*8 limit
if (exc.gt.0.d00) limit=limit1
if (exc.lt.0.d00) limit=limit2
do i=s_max, 1, -1
 if (ro(i)/ro(1).lt.limit) number=number-1
end do
End Subroutine Number_Search
!*********************Four-Point Maximum Search*************************
Subroutine Lambda_Search
implicit none
parameter delta=1.d-09, n4in=1.d00
real*8 lm(4), klm(4), p
complex*16 tr
tr=(0.d00,0.d00)
do i=1, s_max
 tr=tr+f(i)
end do
if (tr.eq.(0.d00,0.d00)) then
 lambda=0.d00
else
lm(1)=0.d00; lm(4)=n4in
p=(lm(4)-lm(1))/3.d00
lm(2)=lm(1)+p; lm(3)=lm(2)+p
klm(1)=k(lm(1)); klm(2)=k(lm(2)); klm(3)=k(lm(3))
do
 klm(4)=k(lm(4))
 p=klm(1); j=1
 do i=2, 4
  if (klm(i).gt.p) then 
   p=klm(i); j=i
  end if
 end do
 if (j.le.3) Exit
 lm(4)=2.d00*lm(4)
end do
do
 p=(lm(4)-lm(1))/3.d00
 lm(2)=lm(1)+p; lm(3)=lm(2)+p+p/1.d02
 klm(2)=k(lm(2)); klm(3)=k(lm(3))
 p=klm(1); j=1
 do i=2, 4
  if (klm(i).gt.p) then 
   p=klm(i); j=i
  end if
 end do
 if (j.eq.1) then
  lm(4)=lm(2); klm(4)=klm(2)
 end if
 if (j.eq.2.or.j.eq.3) then
  lm(1)=lm(j-1); klm(1)=klm(j-1)
  lm(4)=lm(j+1); klm(4)=klm(j+1)
 end if
 if (j.eq.4) then
  lm(1)=lm(3); klm(1)=klm(3)
 end if
 lambda=(lm(4)+lm(1))/2.d00
 if (dabs(klm(4)-klm(1))/(klm(4)+klm(1))/2.d00.lt.delta) Exit
end do
end if
lambda=lambda/1.d00 !
End Subroutine Lambda_Search
!
!**************L-Curve Curvature Calculation*******************************
Real*8 Function k(lmd)
implicit none
real*8, intent(in) :: lmd
real*8 fro, rorola, rola2, rola3, rola4, norm1, norm2, res1, res2
norm1=0.d00; norm2=0.d00; res1=0.d00; res2=0.d00
do i=1, s_max
 fro=ro(i)*ro(i)*(cdabs(f(i))**2)
 rola2=ro(i)*ro(i)+lmd
 rorola=ro(i)*ro(i)/rola2
 rola3=rola2**3
 rola4=rola3*rola2
 rola2=rola2**2
 res1=res1+fro*(rorola-1.d00)/rola2
 res2=res2+fro*(3.d00*rorola-2.d00)/rola3
 norm1=norm1+fro/rola3
 norm2=norm2+fro/rola4
end do
res1=-2.d00*res1; res2=2.d00*res2
norm1=-2.d00*norm1; norm2=6.d00*norm2
k=dabs(res1*norm2-res2*norm1)/dsqrt((res1**2+norm1**2)**3)
End Function k
!
Subroutine Curve_Drow
implicit none
parameter width=1.d01
real*8 step
step=width/1000
lambda=0.d00
do i=1, 1000
write (06,*) lambda, k(lambda)
lambda=lambda+step
end do
End Subroutine Curve_Drow
!
Subroutine Norming_Matrix(n1, n2, l1, l2)
implicit none
integer*4, intent(in) :: n1, n2, l1, l2
real*8 max, mod
do i=n1, n2
   max=-1.d00
  do j=l1, l2
     mod=cdabs(MATRIX(i,j))
     if (mod.gt.max) max=mod
  end do
  j=1; nrm(i)=1.d00
  if (max.lt.1.d00) then
    do
       max=max*2.d00   
       if (max.le.1.d00) then
	     nrm(i)=nrm(i)/2.d00
	     j=j+1
       else 
	     Exit
	   end if 
    end do
   else
    do
       max=max/2.d00
       if (max/2.d00.ge.1.d00) then
	     nrm(i)=nrm(i)*2.d00
	     j=j+1
       else 
	     Exit
	   end if 
     end do
   end if
end do
do i=n1, n2
  do j=l1, l2
       MATRIX(i,j)=MATRIX(i,j)/nrm(i)
  end do
end do
End Subroutine Norming_Matrix
!
Subroutine Norming_Right_Part(n1, n2)
implicit none
integer*4, intent(in) :: n1, n2
do i=n1, n2
  r_p(i,1)=r_p(i,1)/nrm(i)
end do
End Subroutine Norming_Right_Part
!
End Subroutine Reg_SVD_Solver
!

Program drive
implicit none
call Route_with_Field_at_a_Reference_Point
!call IntegrationCheck(1)
!call InnerHuygensCheck(1)
!call RightPartsCheck
!call Legendres
!call Exponents
!call Conversion_Check
!call Integrals_Writing
!call Field_Making_Check
!call Clebsch_Gordan_Single(3, 2, 3, 2, 2)
!call Inc_Field_Coeff(1, 1, 1, 1, 1.d00)
END
!
Subroutine Conversion_Check
use Advertisement
implicit none
m=1
a_e1=(1.d00,1.d00); a_e2=(1.d00,1.d00); a_o1=(1.d00,1.d00); a_o2=(1.d00,1.d00)
c_e1=(1.d00,1.d00); c_e2=(1.d00,1.d00); c_o1=(1.d00,1.d00); c_o2=(1.d00,1.d00)
a_p1=(1.d00,1.d00); a_p2=(1.d00,1.d00); a_m1=(1.d00,1.d00); a_m2=(1.d00,1.d00)
c_p1=(1.d00,1.d00); c_p2=(1.d00,1.d00); c_m1=(1.d00,1.d00); c_m2=(1.d00,1.d00)
print *, c_e1(1)
call Coefficients_Conversion_to_M_M(1, 1, 3)
call Coefficients_Conversion_to_eo(1, 1, 3)
print *, c_e1(1)
End Subroutine Conversion_Check
!
Subroutine Legendres
use Advertisement
implicit none
real*8 p(4), t(4), z, a
p=0.d00; t=0.d00
m=2
z=.5d00
a=dsqrt(1.d00-z*z)
call nLegendre(4, z, a, p, t)
do n=1,4
  print *, p(n) !, t(5)
end do
print *, 30*z*a*(7.d00*z*z-4.d00)
End Subroutine Legendres
!
Subroutine Exponents
use Advertisement
implicit none
complex*16 p, i, ep, be(n_max+terms-1), dbe(n_max+terms-1)
real*8 pl(n_max+terms-1), tl(n_max+terms-1), z, a
integer*4 nn, nmx
m=0; nmx=100
p=(-10.d00, 0.d00)
i=(1.d00, 0.d00)
z=.6d00; a=dsqrt(1.d00-z*z)
ep=cdsin(p)/p
call nLegendre(nmx, z, a, pl, tl)
call nBessel(nmx, p, be, dbe)
do nn=1, nmx
  i=i*(0.d00, 1.d00)
  ep=ep+(2*nn+1)*i*be(nn)*pl(nn)/p
end do
print *, ep, cdexp((0.d00, 1.d00)*p*z)
End Subroutine Exponents

!
Subroutine SVD_Solver
use Advertisement
use IMSLF90
integer*4 i
real*8 singl(2*l_max)
complex*16 r_p(2*n_max,1), sol(2*l_max,1)
if (m.eq.0) then
 r_p(1:2*n_max, 1)=(0.d00,0.d00)
 sol(1:2*l_max, 1)=(0.d00,0.d00)
 do i=1, n_max
  r_p(i,1)=n_M(2,i)
 end do
 call lin_sol_svd(MATRIX(1:n_max, 1:l_max), r_p, sol, s=singl)
 print *, singl(l_max)/singl(1)
 do i=1, l_max
  l_M(2,i)=sol(i,1)
 end do
 r_p(1:2*n_max, 1)=(0.d00,0.d00)
 sol(1:2*l_max, 1)=(0.d00,0.d00)
 do i=1, n_max
  r_p(i,1)=n_N(2,i)
 end do
 call lin_sol_svd(MATRIX(n_max+1:2*n_max, l_max+1:2*l_max), r_p, sol, s=singl)
 print *, singl(l_max)/singl(1)
 do i=1, l_max
  l_N(2,i)=sol(i,1)
 end do
else
 r_p(1:2*n_max, 1)=(0.d00,0.d00)
 sol(1:2*l_max, 1)=(0.d00,0.d00)
 do i=1, n_max
  r_p(i,1)=n_M(2,i)
  r_p(n_max+i,1)=n_N(3,i)
 end do
 call lin_sol_svd(MATRIX(1:2*n_max, 1:2*l_max), r_p, sol, s=singl)
 print *, singl(2*l_max)/singl(1)
 do i=1, l_max
  l_M(2,i)=sol(i,1)
  l_N(3,i)=sol(i+l_max,1)
 end do
 r_p(1:2*n_max, 1)=(0.d00,0.d00)
 sol(1:2*l_max, 1)=(0.d00,0.d00)
 do i=1, n_max
  r_p(i,1)=n_M(3,i)
  r_p(n_max+i,1)=n_N(2,i)
 end do
 do n=1, n_max
  do l=1, l_max
   MATRIX(n, l_max+l)=-MATRIX(n, l_max+l)
   MATRIX(n_max+n, l)=-MATRIX(n_max+n, l)
  end do
 end do
 call lin_sol_svd(MATRIX(1:2*n_max, 1:2*l_max), r_p, sol, s=singl)
 do i=1, l_max
  l_M(3,i)=sol(i,1)
  l_N(2,i)=sol(i+l_max,1)
 end do
end if
End Subroutine SVD_Solver
!
Subroutine InversionCheck
use Advertisement
implicit none
call Preparations
m=m_max
Matrix=(0.d00, 0.d00)
n_M=(1.d00, 0.d00); n_N=(1.d00, 0.d00)
do n=1, n_max
 matrix(n,n)=(2.d00,0.d00)
end do
do n=1+n_max, 2*n_max
 matrix(n,n)=(1.d00,0.d00)
end do
call SVD_Solver
do l=1, l_max
 print *, l_M(2, l)
end do
write (*,*) '******************'
do l=1, l_max
 print *, l_N(2, l)
end do
End subroutine InversionCheck

Subroutine Clebsch_Gordan_Single(j1, j2, j3, m1, m2, C)
implicit none
integer*4, intent(in) :: j1, j2, j3, m1, m2
real*8, intent(out) :: C
integer*4 N, i
real*8 C_1, C_2
N=abs(j1-j2); if (N.lt.abs(m2)) N=abs(m2)
C_1=1.d00;  C_2=0.d00
Call Initial_Value(j1, j2, m1, m2, C_1)
If (j3.lt.N) C=0.d00
If (j3.eq.N) C=C_1
If (j3.gt.N) then ! Main Recursion
  do i=N+1, j3
    if (N.eq.0) then
	  Call Zero_Step(j1, i, m1, C_1, C_2, C)
	else
      Call Main_Recursion_Step(j1, j2, i, m1, m2, C_1, C_2, C)
	end if
    C_2=C_1; C_1=C
  end do
End if
!print *, C
End Subroutine Clebsch_Gordan_Single
!
Subroutine Initial_Value(j1, j2, m1, m2, C_)
implicit none
integer*4, intent(in) :: j1, j2, m1, m2
real*8, intent(out) :: C_
integer*4 i, n1, n2
C_=1.d00
n1=abs(j1-j2); n2=abs(m2)
If (n1.ge.n2) then
  if (j1.ge.j2) then
    call Products(2*j2, 2*n1+1, &
	                 n1+m2, j2-m2+m1, &
			          n1-m2, j2+m2-m1)
    C_=C_ *Sgn(j2, m1, m2)
  else
    call Products(2*j1, 2*n1+1, &
	                     n1+m2, j1-m1, &
						 n1-m2, j1+m1)
	C_=C_*Sgn(j1, m1, 0)
  end if
Else
  if (m2.ge.0) then
    call Products(2*n2+1, j1+j2-n2, &
	                     n2+j1-j2, j2-n2+m1, &
						 n2-j1+j2, j1-m1)
	 C_=C_*Sgn(j1, m1, 0)
  else
    call Products(2*n2+1, j1+j2-n2, &
	                     n2+j1-j2, j2-n2-m1, &
						 n2-j1+j2, j1+m1)
     C_=C_*Sgn(j2, m1, m2)
  end if
End if
Contains
!
Subroutine Products(p1, c1, p2, c2, p3, c3)
integer*4, intent(in) :: p1, p2, p3, c1, c2, c3
do i=1, p2
  C_=C_*(1.d00+1.d00*c2/i)
end do
do i=1, p1
  C_=C_*1.d00*i/(c1+1.d00*i)
end  do
do i=1, p3
  C_=C_*(1.d00+1.d00*c3/i)
end do
C_=dsqrt(C_)
End Subroutine Products
!
integer*4 Function Sgn(n1, n2, n3)
integer*4, intent(in) :: n1, n2, n3
i=n1+n2+n3-2*((n1+n2+n3)/2)
Sgn=-1; if (i.eq.0) Sgn=1
end Function Sgn
End Subroutine Initial_Value
!
Subroutine Main_Recursion_Step(j1, j2, j, m1, m2, C1, C2, C0)
implicit none
integer*4, intent(in) :: j1, j2, j, m1, m2
real*8, intent(in) :: C1, C2
real*8, intent(out) :: C0
real*8 g1, g2, g, n1, n2
g1=j1; g2=j2; g=j; n1=m1; n2=m2
C0=dsqrt(4.d00*g/(g+n2)*g/(g-n2) &
                  *(2*g-1)/(g1+g2+g+1)/(g1-g2+g) &
				  *(2*g+1)/(g2-g1+g)/(g1+g2-g+1)) &
                  *(   &
     ((2*n1-n2)*g*(g-1)-n2*g1*(g1+1)+n2*g2*(g2+1)) &
                                                           /2.d00/g/(g-1)*C1-   &
       dsqrt((g-n2-1)/(g-1)*(g+n2-1)/(g-1) &
              *(g2-g1+g-1)*(g1-g2+g-1)/(2*g-3) &
	          *(g1+g2-g+2)*(g2+g1+g)/(2*g-1)/4.d00)*C2 &
	    		    )
End Subroutine Main_Recursion_Step
!
Subroutine Zero_Step(j1, j3, m1, C1, C2, C0)
implicit none
integer*4, intent(in) :: j1, j3, m1
real*8, intent(in) :: C1, C2
real*8, intent(out) :: C0
real*8 g1, g3, n1
g1=j1; g3=j3; n1=m1
C0=dsqrt((2*g3+1)/g3*(2*g3-1)/g3*4.d00/(2*g1-g3+1)/(2*g1+g3+1)) &
      *(n1*C1-Mlt(j3)*C2) 
Contains
real*8 Function Mlt(j)
integer*4, intent(in) :: j
Mlt=0.d00
If (j.gt.1) Mlt=(g3-1)/2.d00*dsqrt((2*g1-g3+2)/(2*g3-3)*(2*g1+g3)/(2*j3-1))
end Function Mlt
End Subroutine Zero_Step
!
Subroutine A_Pair(nn, nn1, mm, pair)
Use Advertisement
implicit none
integer*4, intent(in) :: nn, nn1, mm
real*8, intent(out) :: pair(0:nn)
integer*4 st, t, min
real*8 C1, C2, C1_1, C1_2, C2_
min=abs(nn-nn1); if (min.eq.1) min=0
st=min; if (min.eq.0) st=1
Call Clebsch_Gordan_Single(nn, nn1, st, min, 1, C1) 
Call Clebsch_Gordan_Single(nn, nn1, st, min, min, C2)
pair(min)=C1*C2
C1_2=C1
st=min+1
Call Clebsch_Gordan_Single(nn, nn1, st, min, 1, C1) 
Call Clebsch_Gordan_Single(nn, nn1, st, min+1, min+1, C2)
pair(min+1)=C1*C2
C1_1=C1; C2_=C2
do t=min+2, nn
  st=t
  call Main_Recursion_Step(nn, nn1, st, mm, 1, C1_1, C1_2, C1)
  C1_2=C1_1; C1_1=C1
  call A_Recursion_Step
  C2_=C2
  pair(t)=C1*C2
end do
!
contains
Subroutine A_Recursion_Step
implicit none
real*8 nn_, t_, nn1_
nn_=nn; t_=t; nn1_=nn1
C2=-C2_* &
       dsqrt((nn_-t_+1.d00)/(nn_+nn1_-t_-1.d00)*(nn_+t_)/(nn1_-nn_+t_)* &
	            (2.d00*t_+1.d00)/(nn_+nn1_+t_+1.d00)*(2.d00*t_)/(nn_-nn1_+t_))
End Subroutine A_Recursion_Step
!
End Subroutine A_Pair
!
